/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         conf_parse
#define yylex           conf_lex
#define yyerror         conf_error
#define yydebug         conf_debug
#define yynerrs         conf_nerrs
#define yylval          conf_lval
#define yychar          conf_char

/* First part of user prologue.  */
#line 24 "conf_yacc.y"

#include "config.h"

#ifdef HAVE_SYS_CDEFS_H
#include <sys/cdefs.h>
#ifdef __RCSID  
__RCSID("$Id: conf_yacc.y,v 1.130 2016/11/25 03:34:22 manu Exp $");
#endif
#endif

#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <syslog.h>
#include <sysexits.h>
#ifdef USE_DMALLOC
#include <dmalloc.h> 
#endif
#include "conf.h"
#include "spf.h"
#include "acl.h"
#include "sync.h"
#include "list.h"
#include "macro.h"
#include "ratelimit.h"
#include "nsupdate.h"
#ifdef USE_DNSRBL
#include "dnsrbl.h"
#endif
#ifdef USE_CURL
#include "urlcheck.h"
#endif
#ifdef USE_LDAP
#include "ldapcheck.h"
#endif
#include "prop.h"
#ifdef USE_GEOIP
#include "geoip.h"
#endif
#ifdef USE_GEOIP2
#include "geoip2.h"
#endif
#ifdef USE_P0F
#include "p0f.h"
#endif
#ifdef USE_SPAMD
#include "spamd.h"
#endif
#include "stat.h"
#include "clock.h"
#include "ratelimit.h"
#include "spf.h"
#include "milter-greylist.h"

#define LEN4 sizeof(struct sockaddr_in)
#define IP4TOSTRING(ip4, str) iptostring(SA(&(ip4)), LEN4, (str), IPADDRSTRLEN)

#define LEN6 sizeof(struct sockaddr_in6)
#define IP6TOSTRING(ip6, str) iptostring(SA(&(ip6)), LEN6, (str), IPADDRSTRLEN)

int conf_lex(void);
void conf_error(char *);


#line 143 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int conf_debug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    TNUMBER = 258,                 /* TNUMBER  */
    ADDR = 259,                    /* ADDR  */
    IPADDR = 260,                  /* IPADDR  */
    IP6ADDR = 261,                 /* IP6ADDR  */
    CIDR = 262,                    /* CIDR  */
    HELO = 263,                    /* HELO  */
    FROM = 264,                    /* FROM  */
    RCPT = 265,                    /* RCPT  */
    EMAIL = 266,                   /* EMAIL  */
    PEER = 267,                    /* PEER  */
    AUTOWHITE = 268,               /* AUTOWHITE  */
    GREYLIST = 269,                /* GREYLIST  */
    NOAUTH = 270,                  /* NOAUTH  */
    NOACCESSDB = 271,              /* NOACCESSDB  */
    EXTENDEDREGEX = 272,           /* EXTENDEDREGEX  */
    NOSPF = 273,                   /* NOSPF  */
    QUIET = 274,                   /* QUIET  */
    TESTMODE = 275,                /* TESTMODE  */
    MULTIRACL = 276,               /* MULTIRACL  */
    VERBOSE = 277,                 /* VERBOSE  */
    PIDFILE = 278,                 /* PIDFILE  */
    GLDUMPFILE = 279,              /* GLDUMPFILE  */
    QSTRING = 280,                 /* QSTRING  */
    TDELAY = 281,                  /* TDELAY  */
    SUBNETMATCH = 282,             /* SUBNETMATCH  */
    SUBNETMATCH6 = 283,            /* SUBNETMATCH6  */
    SOCKET = 284,                  /* SOCKET  */
    USER = 285,                    /* USER  */
    NODETACH = 286,                /* NODETACH  */
    REGEX = 287,                   /* REGEX  */
    REPORT = 288,                  /* REPORT  */
    NONE = 289,                    /* NONE  */
    DELAYS = 290,                  /* DELAYS  */
    NODELAYS = 291,                /* NODELAYS  */
    ALL = 292,                     /* ALL  */
    LAZYAW = 293,                  /* LAZYAW  */
    GLDUMPFREQ = 294,              /* GLDUMPFREQ  */
    GLTIMEOUT = 295,               /* GLTIMEOUT  */
    DOMAIN = 296,                  /* DOMAIN  */
    DOMAINNAME = 297,              /* DOMAINNAME  */
    SYNCADDR = 298,                /* SYNCADDR  */
    SYNCSRCADDR = 299,             /* SYNCSRCADDR  */
    SYNCMAXQLEN = 300,             /* SYNCMAXQLEN  */
    PORT = 301,                    /* PORT  */
    ACL = 302,                     /* ACL  */
    WHITELIST = 303,               /* WHITELIST  */
    DEFAULT = 304,                 /* DEFAULT  */
    STAR = 305,                    /* STAR  */
    DELAYEDREJECT = 306,           /* DELAYEDREJECT  */
    DB = 307,                      /* DB  */
    NODRAC = 308,                  /* NODRAC  */
    DRAC = 309,                    /* DRAC  */
    DUMP_NO_TIME_TRANSLATION = 310, /* DUMP_NO_TIME_TRANSLATION  */
    LOGEXPIRED = 311,              /* LOGEXPIRED  */
    GLXDELAY = 312,                /* GLXDELAY  */
    DNSRBL = 313,                  /* DNSRBL  */
    LIST = 314,                    /* LIST  */
    OPENLIST = 315,                /* OPENLIST  */
    CLOSELIST = 316,               /* CLOSELIST  */
    BLACKLIST = 317,               /* BLACKLIST  */
    FLUSHADDR = 318,               /* FLUSHADDR  */
    CODE = 319,                    /* CODE  */
    ECODE = 320,                   /* ECODE  */
    MSG = 321,                     /* MSG  */
    SM_MACRO = 322,                /* SM_MACRO  */
    UNSET = 323,                   /* UNSET  */
    URLCHECK = 324,                /* URLCHECK  */
    RACL = 325,                    /* RACL  */
    DACL = 326,                    /* DACL  */
    GLHEADER = 327,                /* GLHEADER  */
    BODY = 328,                    /* BODY  */
    MAXPEEK = 329,                 /* MAXPEEK  */
    STAT = 330,                    /* STAT  */
    POSTMSG = 331,                 /* POSTMSG  */
    FORK = 332,                    /* FORK  */
    GETPROP = 333,                 /* GETPROP  */
    CLEAR = 334,                   /* CLEAR  */
    PROP = 335,                    /* PROP  */
    AUTH = 336,                    /* AUTH  */
    TLS = 337,                     /* TLS  */
    SPF = 338,                     /* SPF  */
    MSGSIZE = 339,                 /* MSGSIZE  */
    RCPTCOUNT = 340,               /* RCPTCOUNT  */
    OP = 341,                      /* OP  */
    NO = 342,                      /* NO  */
    SLASH = 343,                   /* SLASH  */
    MINUS = 344,                   /* MINUS  */
    COMMA = 345,                   /* COMMA  */
    TIME = 346,                    /* TIME  */
    GEOIPDB = 347,                 /* GEOIPDB  */
    GEOIPV6DB = 348,               /* GEOIPV6DB  */
    GEOIP = 349,                   /* GEOIP  */
    PASS = 350,                    /* PASS  */
    FAIL = 351,                    /* FAIL  */
    SOFTFAIL = 352,                /* SOFTFAIL  */
    NEUTRAL = 353,                 /* NEUTRAL  */
    UNKNWON = 354,                 /* UNKNWON  */
    ERROR = 355,                   /* ERROR  */
    SELF = 356,                    /* SELF  */
    SPF_STATUS = 357,              /* SPF_STATUS  */
    LDAPCONF = 358,                /* LDAPCONF  */
    LDAPCHECK = 359,               /* LDAPCHECK  */
    LOGFAC = 360,                  /* LOGFAC  */
    LOGFAC_KERN = 361,             /* LOGFAC_KERN  */
    LOGFAC_USER = 362,             /* LOGFAC_USER  */
    LOGFAC_MAIL = 363,             /* LOGFAC_MAIL  */
    LOGFAC_DAEMON = 364,           /* LOGFAC_DAEMON  */
    LOGFAC_AUTH = 365,             /* LOGFAC_AUTH  */
    LOGFAC_SYSLOG = 366,           /* LOGFAC_SYSLOG  */
    LOGFAC_LPR = 367,              /* LOGFAC_LPR  */
    LOGFAC_NEWS = 368,             /* LOGFAC_NEWS  */
    LOGFAC_UUCP = 369,             /* LOGFAC_UUCP  */
    LOGFAC_CRON = 370,             /* LOGFAC_CRON  */
    LOGFAC_AUTHPRIV = 371,         /* LOGFAC_AUTHPRIV  */
    LOGFAC_FTP = 372,              /* LOGFAC_FTP  */
    LOGFAC_LOCAL0 = 373,           /* LOGFAC_LOCAL0  */
    LOGFAC_LOCAL1 = 374,           /* LOGFAC_LOCAL1  */
    LOGFAC_LOCAL2 = 375,           /* LOGFAC_LOCAL2  */
    LOGFAC_LOCAL3 = 376,           /* LOGFAC_LOCAL3  */
    LOGFAC_LOCAL4 = 377,           /* LOGFAC_LOCAL4  */
    LOGFAC_LOCAL5 = 378,           /* LOGFAC_LOCAL5  */
    LOGFAC_LOCAL6 = 379,           /* LOGFAC_LOCAL6  */
    LOGFAC_LOCAL7 = 380,           /* LOGFAC_LOCAL7  */
    P0F = 381,                     /* P0F  */
    P0FSOCK = 382,                 /* P0FSOCK  */
    DKIMCHECK = 383,               /* DKIMCHECK  */
    SPAMDSOCK = 384,               /* SPAMDSOCK  */
    SPAMDSOCKT = 385,              /* SPAMDSOCKT  */
    SPAMD = 386,                   /* SPAMD  */
    DOMAINEXACT = 387,             /* DOMAINEXACT  */
    ADDHEADER = 388,               /* ADDHEADER  */
    NOLOG = 389,                   /* NOLOG  */
    LDAPBINDDN = 390,              /* LDAPBINDDN  */
    LDAPBINDPW = 391,              /* LDAPBINDPW  */
    TARPIT = 392,                  /* TARPIT  */
    TARPIT_SCOPE = 393,            /* TARPIT_SCOPE  */
    SESSION = 394,                 /* SESSION  */
    COMMAND = 395,                 /* COMMAND  */
    MX = 396,                      /* MX  */
    RATELIMIT = 397,               /* RATELIMIT  */
    KEY = 398,                     /* KEY  */
    DOMATCH = 399,                 /* DOMATCH  */
    DATA = 400,                    /* DATA  */
    LOCALADDR = 401,               /* LOCALADDR  */
    ADDFOOTER = 402,               /* ADDFOOTER  */
    CONTINUE = 403,                /* CONTINUE  */
    FIXLDAPCHECK = 404,            /* FIXLDAPCHECK  */
    SUBJTAG = 405,                 /* SUBJTAG  */
    NOENCODE = 406,                /* NOENCODE  */
    NOESCAPE = 407,                /* NOESCAPE  */
    TSIG = 408,                    /* TSIG  */
    NSUPDATE = 409,                /* NSUPDATE  */
    SERVERS = 410,                 /* SERVERS  */
    RNAME = 411,                   /* RNAME  */
    RVALUE = 412,                  /* RVALUE  */
    TTL = 413,                     /* TTL  */
    CLASS = 414,                   /* CLASS  */
    TYPE = 415,                    /* TYPE  */
    UNBRACKET = 416,               /* UNBRACKET  */
    SET = 417,                     /* SET  */
    RSET = 418,                    /* RSET  */
    EQSET = 419,                   /* EQSET  */
    INCSET = 420,                  /* INCSET  */
    DECSET = 421,                  /* DECSET  */
    LOG = 422,                     /* LOG  */
    RAWFROM = 423,                 /* RAWFROM  */
    GEOIP2DB = 424                 /* GEOIP2DB  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define TNUMBER 258
#define ADDR 259
#define IPADDR 260
#define IP6ADDR 261
#define CIDR 262
#define HELO 263
#define FROM 264
#define RCPT 265
#define EMAIL 266
#define PEER 267
#define AUTOWHITE 268
#define GREYLIST 269
#define NOAUTH 270
#define NOACCESSDB 271
#define EXTENDEDREGEX 272
#define NOSPF 273
#define QUIET 274
#define TESTMODE 275
#define MULTIRACL 276
#define VERBOSE 277
#define PIDFILE 278
#define GLDUMPFILE 279
#define QSTRING 280
#define TDELAY 281
#define SUBNETMATCH 282
#define SUBNETMATCH6 283
#define SOCKET 284
#define USER 285
#define NODETACH 286
#define REGEX 287
#define REPORT 288
#define NONE 289
#define DELAYS 290
#define NODELAYS 291
#define ALL 292
#define LAZYAW 293
#define GLDUMPFREQ 294
#define GLTIMEOUT 295
#define DOMAIN 296
#define DOMAINNAME 297
#define SYNCADDR 298
#define SYNCSRCADDR 299
#define SYNCMAXQLEN 300
#define PORT 301
#define ACL 302
#define WHITELIST 303
#define DEFAULT 304
#define STAR 305
#define DELAYEDREJECT 306
#define DB 307
#define NODRAC 308
#define DRAC 309
#define DUMP_NO_TIME_TRANSLATION 310
#define LOGEXPIRED 311
#define GLXDELAY 312
#define DNSRBL 313
#define LIST 314
#define OPENLIST 315
#define CLOSELIST 316
#define BLACKLIST 317
#define FLUSHADDR 318
#define CODE 319
#define ECODE 320
#define MSG 321
#define SM_MACRO 322
#define UNSET 323
#define URLCHECK 324
#define RACL 325
#define DACL 326
#define GLHEADER 327
#define BODY 328
#define MAXPEEK 329
#define STAT 330
#define POSTMSG 331
#define FORK 332
#define GETPROP 333
#define CLEAR 334
#define PROP 335
#define AUTH 336
#define TLS 337
#define SPF 338
#define MSGSIZE 339
#define RCPTCOUNT 340
#define OP 341
#define NO 342
#define SLASH 343
#define MINUS 344
#define COMMA 345
#define TIME 346
#define GEOIPDB 347
#define GEOIPV6DB 348
#define GEOIP 349
#define PASS 350
#define FAIL 351
#define SOFTFAIL 352
#define NEUTRAL 353
#define UNKNWON 354
#define ERROR 355
#define SELF 356
#define SPF_STATUS 357
#define LDAPCONF 358
#define LDAPCHECK 359
#define LOGFAC 360
#define LOGFAC_KERN 361
#define LOGFAC_USER 362
#define LOGFAC_MAIL 363
#define LOGFAC_DAEMON 364
#define LOGFAC_AUTH 365
#define LOGFAC_SYSLOG 366
#define LOGFAC_LPR 367
#define LOGFAC_NEWS 368
#define LOGFAC_UUCP 369
#define LOGFAC_CRON 370
#define LOGFAC_AUTHPRIV 371
#define LOGFAC_FTP 372
#define LOGFAC_LOCAL0 373
#define LOGFAC_LOCAL1 374
#define LOGFAC_LOCAL2 375
#define LOGFAC_LOCAL3 376
#define LOGFAC_LOCAL4 377
#define LOGFAC_LOCAL5 378
#define LOGFAC_LOCAL6 379
#define LOGFAC_LOCAL7 380
#define P0F 381
#define P0FSOCK 382
#define DKIMCHECK 383
#define SPAMDSOCK 384
#define SPAMDSOCKT 385
#define SPAMD 386
#define DOMAINEXACT 387
#define ADDHEADER 388
#define NOLOG 389
#define LDAPBINDDN 390
#define LDAPBINDPW 391
#define TARPIT 392
#define TARPIT_SCOPE 393
#define SESSION 394
#define COMMAND 395
#define MX 396
#define RATELIMIT 397
#define KEY 398
#define DOMATCH 399
#define DATA 400
#define LOCALADDR 401
#define ADDFOOTER 402
#define CONTINUE 403
#define FIXLDAPCHECK 404
#define SUBJTAG 405
#define NOENCODE 406
#define NOESCAPE 407
#define TSIG 408
#define NSUPDATE 409
#define SERVERS 410
#define RNAME 411
#define RVALUE 412
#define TTL 413
#define CLASS 414
#define TYPE 415
#define UNBRACKET 416
#define SET 417
#define RSET 418
#define EQSET 419
#define INCSET 420
#define DECSET 421
#define LOG 422
#define RAWFROM 423
#define GEOIP2DB 424

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 89 "conf_yacc.y"

	struct sockaddr_in ipaddr;
#ifdef AF_INET6
	struct sockaddr_in6 ip6addr;
#else
	struct sockaddr_in ip6addr;	/* XXX: for dummy */
#endif
	int cidr;
	char email[ADDRLEN + 1];
	char domainname[ADDRLEN + 1];
	char qstring[QSTRLEN + 1];
	char delay[NUMLEN + 1];
	char regex[REGEXLEN + 1];
	enum operator op; 
	char prop[QSTRLEN + 1];
	enum spf_status spf_status;
	enum spf_status dkim_status;
	char spamdsockt[QSTRLEN + 1];
	int ratelimit_type;
	

#line 553 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE conf_lval;


int conf_parse (void);



/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TNUMBER = 3,                    /* TNUMBER  */
  YYSYMBOL_ADDR = 4,                       /* ADDR  */
  YYSYMBOL_IPADDR = 5,                     /* IPADDR  */
  YYSYMBOL_IP6ADDR = 6,                    /* IP6ADDR  */
  YYSYMBOL_CIDR = 7,                       /* CIDR  */
  YYSYMBOL_HELO = 8,                       /* HELO  */
  YYSYMBOL_FROM = 9,                       /* FROM  */
  YYSYMBOL_RCPT = 10,                      /* RCPT  */
  YYSYMBOL_EMAIL = 11,                     /* EMAIL  */
  YYSYMBOL_PEER = 12,                      /* PEER  */
  YYSYMBOL_AUTOWHITE = 13,                 /* AUTOWHITE  */
  YYSYMBOL_GREYLIST = 14,                  /* GREYLIST  */
  YYSYMBOL_NOAUTH = 15,                    /* NOAUTH  */
  YYSYMBOL_NOACCESSDB = 16,                /* NOACCESSDB  */
  YYSYMBOL_EXTENDEDREGEX = 17,             /* EXTENDEDREGEX  */
  YYSYMBOL_NOSPF = 18,                     /* NOSPF  */
  YYSYMBOL_QUIET = 19,                     /* QUIET  */
  YYSYMBOL_TESTMODE = 20,                  /* TESTMODE  */
  YYSYMBOL_MULTIRACL = 21,                 /* MULTIRACL  */
  YYSYMBOL_VERBOSE = 22,                   /* VERBOSE  */
  YYSYMBOL_PIDFILE = 23,                   /* PIDFILE  */
  YYSYMBOL_GLDUMPFILE = 24,                /* GLDUMPFILE  */
  YYSYMBOL_QSTRING = 25,                   /* QSTRING  */
  YYSYMBOL_TDELAY = 26,                    /* TDELAY  */
  YYSYMBOL_SUBNETMATCH = 27,               /* SUBNETMATCH  */
  YYSYMBOL_SUBNETMATCH6 = 28,              /* SUBNETMATCH6  */
  YYSYMBOL_SOCKET = 29,                    /* SOCKET  */
  YYSYMBOL_USER = 30,                      /* USER  */
  YYSYMBOL_NODETACH = 31,                  /* NODETACH  */
  YYSYMBOL_REGEX = 32,                     /* REGEX  */
  YYSYMBOL_REPORT = 33,                    /* REPORT  */
  YYSYMBOL_NONE = 34,                      /* NONE  */
  YYSYMBOL_DELAYS = 35,                    /* DELAYS  */
  YYSYMBOL_NODELAYS = 36,                  /* NODELAYS  */
  YYSYMBOL_ALL = 37,                       /* ALL  */
  YYSYMBOL_LAZYAW = 38,                    /* LAZYAW  */
  YYSYMBOL_GLDUMPFREQ = 39,                /* GLDUMPFREQ  */
  YYSYMBOL_GLTIMEOUT = 40,                 /* GLTIMEOUT  */
  YYSYMBOL_DOMAIN = 41,                    /* DOMAIN  */
  YYSYMBOL_DOMAINNAME = 42,                /* DOMAINNAME  */
  YYSYMBOL_SYNCADDR = 43,                  /* SYNCADDR  */
  YYSYMBOL_SYNCSRCADDR = 44,               /* SYNCSRCADDR  */
  YYSYMBOL_SYNCMAXQLEN = 45,               /* SYNCMAXQLEN  */
  YYSYMBOL_PORT = 46,                      /* PORT  */
  YYSYMBOL_ACL = 47,                       /* ACL  */
  YYSYMBOL_WHITELIST = 48,                 /* WHITELIST  */
  YYSYMBOL_DEFAULT = 49,                   /* DEFAULT  */
  YYSYMBOL_STAR = 50,                      /* STAR  */
  YYSYMBOL_DELAYEDREJECT = 51,             /* DELAYEDREJECT  */
  YYSYMBOL_DB = 52,                        /* DB  */
  YYSYMBOL_NODRAC = 53,                    /* NODRAC  */
  YYSYMBOL_DRAC = 54,                      /* DRAC  */
  YYSYMBOL_DUMP_NO_TIME_TRANSLATION = 55,  /* DUMP_NO_TIME_TRANSLATION  */
  YYSYMBOL_LOGEXPIRED = 56,                /* LOGEXPIRED  */
  YYSYMBOL_GLXDELAY = 57,                  /* GLXDELAY  */
  YYSYMBOL_DNSRBL = 58,                    /* DNSRBL  */
  YYSYMBOL_LIST = 59,                      /* LIST  */
  YYSYMBOL_OPENLIST = 60,                  /* OPENLIST  */
  YYSYMBOL_CLOSELIST = 61,                 /* CLOSELIST  */
  YYSYMBOL_BLACKLIST = 62,                 /* BLACKLIST  */
  YYSYMBOL_FLUSHADDR = 63,                 /* FLUSHADDR  */
  YYSYMBOL_CODE = 64,                      /* CODE  */
  YYSYMBOL_ECODE = 65,                     /* ECODE  */
  YYSYMBOL_MSG = 66,                       /* MSG  */
  YYSYMBOL_SM_MACRO = 67,                  /* SM_MACRO  */
  YYSYMBOL_UNSET = 68,                     /* UNSET  */
  YYSYMBOL_URLCHECK = 69,                  /* URLCHECK  */
  YYSYMBOL_RACL = 70,                      /* RACL  */
  YYSYMBOL_DACL = 71,                      /* DACL  */
  YYSYMBOL_GLHEADER = 72,                  /* GLHEADER  */
  YYSYMBOL_BODY = 73,                      /* BODY  */
  YYSYMBOL_MAXPEEK = 74,                   /* MAXPEEK  */
  YYSYMBOL_STAT = 75,                      /* STAT  */
  YYSYMBOL_POSTMSG = 76,                   /* POSTMSG  */
  YYSYMBOL_FORK = 77,                      /* FORK  */
  YYSYMBOL_GETPROP = 78,                   /* GETPROP  */
  YYSYMBOL_CLEAR = 79,                     /* CLEAR  */
  YYSYMBOL_PROP = 80,                      /* PROP  */
  YYSYMBOL_AUTH = 81,                      /* AUTH  */
  YYSYMBOL_TLS = 82,                       /* TLS  */
  YYSYMBOL_SPF = 83,                       /* SPF  */
  YYSYMBOL_MSGSIZE = 84,                   /* MSGSIZE  */
  YYSYMBOL_RCPTCOUNT = 85,                 /* RCPTCOUNT  */
  YYSYMBOL_OP = 86,                        /* OP  */
  YYSYMBOL_NO = 87,                        /* NO  */
  YYSYMBOL_SLASH = 88,                     /* SLASH  */
  YYSYMBOL_MINUS = 89,                     /* MINUS  */
  YYSYMBOL_COMMA = 90,                     /* COMMA  */
  YYSYMBOL_TIME = 91,                      /* TIME  */
  YYSYMBOL_GEOIPDB = 92,                   /* GEOIPDB  */
  YYSYMBOL_GEOIPV6DB = 93,                 /* GEOIPV6DB  */
  YYSYMBOL_GEOIP = 94,                     /* GEOIP  */
  YYSYMBOL_PASS = 95,                      /* PASS  */
  YYSYMBOL_FAIL = 96,                      /* FAIL  */
  YYSYMBOL_SOFTFAIL = 97,                  /* SOFTFAIL  */
  YYSYMBOL_NEUTRAL = 98,                   /* NEUTRAL  */
  YYSYMBOL_UNKNWON = 99,                   /* UNKNWON  */
  YYSYMBOL_ERROR = 100,                    /* ERROR  */
  YYSYMBOL_SELF = 101,                     /* SELF  */
  YYSYMBOL_SPF_STATUS = 102,               /* SPF_STATUS  */
  YYSYMBOL_LDAPCONF = 103,                 /* LDAPCONF  */
  YYSYMBOL_LDAPCHECK = 104,                /* LDAPCHECK  */
  YYSYMBOL_LOGFAC = 105,                   /* LOGFAC  */
  YYSYMBOL_LOGFAC_KERN = 106,              /* LOGFAC_KERN  */
  YYSYMBOL_LOGFAC_USER = 107,              /* LOGFAC_USER  */
  YYSYMBOL_LOGFAC_MAIL = 108,              /* LOGFAC_MAIL  */
  YYSYMBOL_LOGFAC_DAEMON = 109,            /* LOGFAC_DAEMON  */
  YYSYMBOL_LOGFAC_AUTH = 110,              /* LOGFAC_AUTH  */
  YYSYMBOL_LOGFAC_SYSLOG = 111,            /* LOGFAC_SYSLOG  */
  YYSYMBOL_LOGFAC_LPR = 112,               /* LOGFAC_LPR  */
  YYSYMBOL_LOGFAC_NEWS = 113,              /* LOGFAC_NEWS  */
  YYSYMBOL_LOGFAC_UUCP = 114,              /* LOGFAC_UUCP  */
  YYSYMBOL_LOGFAC_CRON = 115,              /* LOGFAC_CRON  */
  YYSYMBOL_LOGFAC_AUTHPRIV = 116,          /* LOGFAC_AUTHPRIV  */
  YYSYMBOL_LOGFAC_FTP = 117,               /* LOGFAC_FTP  */
  YYSYMBOL_LOGFAC_LOCAL0 = 118,            /* LOGFAC_LOCAL0  */
  YYSYMBOL_LOGFAC_LOCAL1 = 119,            /* LOGFAC_LOCAL1  */
  YYSYMBOL_LOGFAC_LOCAL2 = 120,            /* LOGFAC_LOCAL2  */
  YYSYMBOL_LOGFAC_LOCAL3 = 121,            /* LOGFAC_LOCAL3  */
  YYSYMBOL_LOGFAC_LOCAL4 = 122,            /* LOGFAC_LOCAL4  */
  YYSYMBOL_LOGFAC_LOCAL5 = 123,            /* LOGFAC_LOCAL5  */
  YYSYMBOL_LOGFAC_LOCAL6 = 124,            /* LOGFAC_LOCAL6  */
  YYSYMBOL_LOGFAC_LOCAL7 = 125,            /* LOGFAC_LOCAL7  */
  YYSYMBOL_P0F = 126,                      /* P0F  */
  YYSYMBOL_P0FSOCK = 127,                  /* P0FSOCK  */
  YYSYMBOL_DKIMCHECK = 128,                /* DKIMCHECK  */
  YYSYMBOL_SPAMDSOCK = 129,                /* SPAMDSOCK  */
  YYSYMBOL_SPAMDSOCKT = 130,               /* SPAMDSOCKT  */
  YYSYMBOL_SPAMD = 131,                    /* SPAMD  */
  YYSYMBOL_DOMAINEXACT = 132,              /* DOMAINEXACT  */
  YYSYMBOL_ADDHEADER = 133,                /* ADDHEADER  */
  YYSYMBOL_NOLOG = 134,                    /* NOLOG  */
  YYSYMBOL_LDAPBINDDN = 135,               /* LDAPBINDDN  */
  YYSYMBOL_LDAPBINDPW = 136,               /* LDAPBINDPW  */
  YYSYMBOL_TARPIT = 137,                   /* TARPIT  */
  YYSYMBOL_TARPIT_SCOPE = 138,             /* TARPIT_SCOPE  */
  YYSYMBOL_SESSION = 139,                  /* SESSION  */
  YYSYMBOL_COMMAND = 140,                  /* COMMAND  */
  YYSYMBOL_MX = 141,                       /* MX  */
  YYSYMBOL_RATELIMIT = 142,                /* RATELIMIT  */
  YYSYMBOL_KEY = 143,                      /* KEY  */
  YYSYMBOL_DOMATCH = 144,                  /* DOMATCH  */
  YYSYMBOL_DATA = 145,                     /* DATA  */
  YYSYMBOL_LOCALADDR = 146,                /* LOCALADDR  */
  YYSYMBOL_ADDFOOTER = 147,                /* ADDFOOTER  */
  YYSYMBOL_CONTINUE = 148,                 /* CONTINUE  */
  YYSYMBOL_FIXLDAPCHECK = 149,             /* FIXLDAPCHECK  */
  YYSYMBOL_SUBJTAG = 150,                  /* SUBJTAG  */
  YYSYMBOL_NOENCODE = 151,                 /* NOENCODE  */
  YYSYMBOL_NOESCAPE = 152,                 /* NOESCAPE  */
  YYSYMBOL_TSIG = 153,                     /* TSIG  */
  YYSYMBOL_NSUPDATE = 154,                 /* NSUPDATE  */
  YYSYMBOL_SERVERS = 155,                  /* SERVERS  */
  YYSYMBOL_RNAME = 156,                    /* RNAME  */
  YYSYMBOL_RVALUE = 157,                   /* RVALUE  */
  YYSYMBOL_TTL = 158,                      /* TTL  */
  YYSYMBOL_CLASS = 159,                    /* CLASS  */
  YYSYMBOL_TYPE = 160,                     /* TYPE  */
  YYSYMBOL_UNBRACKET = 161,                /* UNBRACKET  */
  YYSYMBOL_SET = 162,                      /* SET  */
  YYSYMBOL_RSET = 163,                     /* RSET  */
  YYSYMBOL_EQSET = 164,                    /* EQSET  */
  YYSYMBOL_INCSET = 165,                   /* INCSET  */
  YYSYMBOL_DECSET = 166,                   /* DECSET  */
  YYSYMBOL_LOG = 167,                      /* LOG  */
  YYSYMBOL_RAWFROM = 168,                  /* RAWFROM  */
  YYSYMBOL_GEOIP2DB = 169,                 /* GEOIP2DB  */
  YYSYMBOL_170_n_ = 170,                   /* '\n'  */
  YYSYMBOL_YYACCEPT = 171,                 /* $accept  */
  YYSYMBOL_lines = 172,                    /* lines  */
  YYSYMBOL_netblock = 173,                 /* netblock  */
  YYSYMBOL_fromaddr = 174,                 /* fromaddr  */
  YYSYMBOL_rawfromaddr = 175,              /* rawfromaddr  */
  YYSYMBOL_rcptaddr = 176,                 /* rcptaddr  */
  YYSYMBOL_fromregex = 177,                /* fromregex  */
  YYSYMBOL_rawfromregex = 178,             /* rawfromregex  */
  YYSYMBOL_rcptregex = 179,                /* rcptregex  */
  YYSYMBOL_domainaddr = 180,               /* domainaddr  */
  YYSYMBOL_domainregex = 181,              /* domainregex  */
  YYSYMBOL_peeraddr = 182,                 /* peeraddr  */
  YYSYMBOL_autowhite = 183,                /* autowhite  */
  YYSYMBOL_greylist = 184,                 /* greylist  */
  YYSYMBOL_tarpit = 185,                   /* tarpit  */
  YYSYMBOL_tarpit_scope = 186,             /* tarpit_scope  */
  YYSYMBOL_verbose = 187,                  /* verbose  */
  YYSYMBOL_dump_no_time_translation = 188, /* dump_no_time_translation  */
  YYSYMBOL_logexpired = 189,               /* logexpired  */
  YYSYMBOL_quiet = 190,                    /* quiet  */
  YYSYMBOL_noauth = 191,                   /* noauth  */
  YYSYMBOL_multiracl = 192,                /* multiracl  */
  YYSYMBOL_noaccessdb = 193,               /* noaccessdb  */
  YYSYMBOL_extendedregex = 194,            /* extendedregex  */
  YYSYMBOL_unbracket = 195,                /* unbracket  */
  YYSYMBOL_nospf = 196,                    /* nospf  */
  YYSYMBOL_delayedreject = 197,            /* delayedreject  */
  YYSYMBOL_testmode = 198,                 /* testmode  */
  YYSYMBOL_nodetach = 199,                 /* nodetach  */
  YYSYMBOL_lazyaw = 200,                   /* lazyaw  */
  YYSYMBOL_domainexact = 201,              /* domainexact  */
  YYSYMBOL_pidfile = 202,                  /* pidfile  */
  YYSYMBOL_dumpfile = 203,                 /* dumpfile  */
  YYSYMBOL_subnetmatch = 204,              /* subnetmatch  */
  YYSYMBOL_subnetmatch6 = 205,             /* subnetmatch6  */
  YYSYMBOL_socket = 206,                   /* socket  */
  YYSYMBOL_user = 207,                     /* user  */
  YYSYMBOL_p0fsockdef = 208,               /* p0fsockdef  */
  YYSYMBOL_spamdsockdef = 209,             /* spamdsockdef  */
  YYSYMBOL_tsigdef = 210,                  /* tsigdef  */
  YYSYMBOL_nsupdatedef = 211,              /* nsupdatedef  */
  YYSYMBOL_nsupdatedefitems = 212,         /* nsupdatedefitems  */
  YYSYMBOL_nsupdatedefservers = 213,       /* nsupdatedefservers  */
  YYSYMBOL_nsupdatedefrname = 214,         /* nsupdatedefrname  */
  YYSYMBOL_nsupdatedefrvalue = 215,        /* nsupdatedefrvalue  */
  YYSYMBOL_nsupdatedefttl = 216,           /* nsupdatedefttl  */
  YYSYMBOL_nsupdatedefclass = 217,         /* nsupdatedefclass  */
  YYSYMBOL_nsupdatedeftype = 218,          /* nsupdatedeftype  */
  YYSYMBOL_nsupdatedeftsig = 219,          /* nsupdatedeftsig  */
  YYSYMBOL_geoipdb = 220,                  /* geoipdb  */
  YYSYMBOL_geoipv6db = 221,                /* geoipv6db  */
  YYSYMBOL_geoip2db = 222,                 /* geoip2db  */
  YYSYMBOL_report = 223,                   /* report  */
  YYSYMBOL_logfac = 224,                   /* logfac  */
  YYSYMBOL_statdef = 225,                  /* statdef  */
  YYSYMBOL_dumpfreq = 226,                 /* dumpfreq  */
  YYSYMBOL_timeout = 227,                  /* timeout  */
  YYSYMBOL_syncaddr = 228,                 /* syncaddr  */
  YYSYMBOL_syncsrcaddr = 229,              /* syncsrcaddr  */
  YYSYMBOL_syncmaxqlen = 230,              /* syncmaxqlen  */
  YYSYMBOL_ratelimitdef = 231,             /* ratelimitdef  */
  YYSYMBOL_access_list = 232,              /* access_list  */
  YYSYMBOL_rcpt_access_list = 233,         /* rcpt_access_list  */
  YYSYMBOL_data_access_list = 234,         /* data_access_list  */
  YYSYMBOL_id = 235,                       /* id  */
  YYSYMBOL_acl_entry = 236,                /* acl_entry  */
  YYSYMBOL_acl_default_entry = 237,        /* acl_default_entry  */
  YYSYMBOL_acl_plain_entry = 238,          /* acl_plain_entry  */
  YYSYMBOL_acl_clauses = 239,              /* acl_clauses  */
  YYSYMBOL_acl_clause = 240,               /* acl_clause  */
  YYSYMBOL_acl_values = 241,               /* acl_values  */
  YYSYMBOL_acl_value = 242,                /* acl_value  */
  YYSYMBOL_greylist_value = 243,           /* greylist_value  */
  YYSYMBOL_autowhite_value = 244,          /* autowhite_value  */
  YYSYMBOL_tarpit_scope_value = 245,       /* tarpit_scope_value  */
  YYSYMBOL_flush_value = 246,              /* flush_value  */
  YYSYMBOL_nolog_value = 247,              /* nolog_value  */
  YYSYMBOL_code_value = 248,               /* code_value  */
  YYSYMBOL_ecode_value = 249,              /* ecode_value  */
  YYSYMBOL_msg_value = 250,                /* msg_value  */
  YYSYMBOL_report_value = 251,             /* report_value  */
  YYSYMBOL_addheader_value = 252,          /* addheader_value  */
  YYSYMBOL_addfooter_value = 253,          /* addfooter_value  */
  YYSYMBOL_subjtag_value = 254,            /* subjtag_value  */
  YYSYMBOL_maxpeek_value = 255,            /* maxpeek_value  */
  YYSYMBOL_no_clause = 256,                /* no_clause  */
  YYSYMBOL_time_clause = 257,              /* time_clause  */
  YYSYMBOL_p0f_clause = 258,               /* p0f_clause  */
  YYSYMBOL_p0fregex_clause = 259,          /* p0fregex_clause  */
  YYSYMBOL_spamd_clause = 260,             /* spamd_clause  */
  YYSYMBOL_spamd_score_clause = 261,       /* spamd_score_clause  */
  YYSYMBOL_spamd_score_prop_clause = 262,  /* spamd_score_prop_clause  */
  YYSYMBOL_geoip_clause = 263,             /* geoip_clause  */
  YYSYMBOL_helo_clause = 264,              /* helo_clause  */
  YYSYMBOL_heloregex_clause = 265,         /* heloregex_clause  */
  YYSYMBOL_fromaddr_clause = 266,          /* fromaddr_clause  */
  YYSYMBOL_rawfromaddr_clause = 267,       /* rawfromaddr_clause  */
  YYSYMBOL_fromregex_clause = 268,         /* fromregex_clause  */
  YYSYMBOL_rawfromregex_clause = 269,      /* rawfromregex_clause  */
  YYSYMBOL_rcptaddr_clause = 270,          /* rcptaddr_clause  */
  YYSYMBOL_rcptregex_clause = 271,         /* rcptregex_clause  */
  YYSYMBOL_domainaddr_clause = 272,        /* domainaddr_clause  */
  YYSYMBOL_domainregex_clause = 273,       /* domainregex_clause  */
  YYSYMBOL_dnsrbl_clause = 274,            /* dnsrbl_clause  */
  YYSYMBOL_mx_clause = 275,                /* mx_clause  */
  YYSYMBOL_macro_clause = 276,             /* macro_clause  */
  YYSYMBOL_ratelimit_clause = 277,         /* ratelimit_clause  */
  YYSYMBOL_header_clause = 278,            /* header_clause  */
  YYSYMBOL_headerregex_clause = 279,       /* headerregex_clause  */
  YYSYMBOL_tarpit_clause = 280,            /* tarpit_clause  */
  YYSYMBOL_nsupdate_clause = 281,          /* nsupdate_clause  */
  YYSYMBOL_log_clause = 282,               /* log_clause  */
  YYSYMBOL_body_clause = 283,              /* body_clause  */
  YYSYMBOL_bodyregex_clause = 284,         /* bodyregex_clause  */
  YYSYMBOL_auth_clause = 285,              /* auth_clause  */
  YYSYMBOL_authregex_clause = 286,         /* authregex_clause  */
  YYSYMBOL_tls_clause = 287,               /* tls_clause  */
  YYSYMBOL_tlsregex_clause = 288,          /* tlsregex_clause  */
  YYSYMBOL_spf_clause = 289,               /* spf_clause  */
  YYSYMBOL_spf_compat_clause = 290,        /* spf_compat_clause  */
  YYSYMBOL_dkim_clause = 291,              /* dkim_clause  */
  YYSYMBOL_urlcheck_clause = 292,          /* urlcheck_clause  */
  YYSYMBOL_ldapcheck_clause = 293,         /* ldapcheck_clause  */
  YYSYMBOL_eqsetstring_clause = 294,       /* eqsetstring_clause  */
  YYSYMBOL_eqrsetstring_clause = 295,      /* eqrsetstring_clause  */
  YYSYMBOL_incsetstring_clause = 296,      /* incsetstring_clause  */
  YYSYMBOL_incrsetstring_clause = 297,     /* incrsetstring_clause  */
  YYSYMBOL_decsetstring_clause = 298,      /* decsetstring_clause  */
  YYSYMBOL_decrsetstring_clause = 299,     /* decrsetstring_clause  */
  YYSYMBOL_eqsetnum_clause = 300,          /* eqsetnum_clause  */
  YYSYMBOL_eqrsetnum_clause = 301,         /* eqrsetnum_clause  */
  YYSYMBOL_incsetnum_clause = 302,         /* incsetnum_clause  */
  YYSYMBOL_incrsetnum_clause = 303,        /* incrsetnum_clause  */
  YYSYMBOL_decsetnum_clause = 304,         /* decsetnum_clause  */
  YYSYMBOL_decrsetnum_clause = 305,        /* decrsetnum_clause  */
  YYSYMBOL_eqsetprop_clause = 306,         /* eqsetprop_clause  */
  YYSYMBOL_eqrsetprop_clause = 307,        /* eqrsetprop_clause  */
  YYSYMBOL_incsetprop_clause = 308,        /* incsetprop_clause  */
  YYSYMBOL_incrsetprop_clause = 309,       /* incrsetprop_clause  */
  YYSYMBOL_decsetprop_clause = 310,        /* decsetprop_clause  */
  YYSYMBOL_decrsetprop_clause = 311,       /* decrsetprop_clause  */
  YYSYMBOL_propstr_clause = 312,           /* propstr_clause  */
  YYSYMBOL_propglob_clause = 313,          /* propglob_clause  */
  YYSYMBOL_propnum_clause = 314,           /* propnum_clause  */
  YYSYMBOL_propprop_clause = 315,          /* propprop_clause  */
  YYSYMBOL_propregex_clause = 316,         /* propregex_clause  */
  YYSYMBOL_bodyprop_clause = 317,          /* bodyprop_clause  */
  YYSYMBOL_headerprop_clause = 318,        /* headerprop_clause  */
  YYSYMBOL_list_clause = 319,              /* list_clause  */
  YYSYMBOL_netblock_clause = 320,          /* netblock_clause  */
  YYSYMBOL_dracdb = 321,                   /* dracdb  */
  YYSYMBOL_msgsize_clause = 322,           /* msgsize_clause  */
  YYSYMBOL_msgsize_prop_clause = 323,      /* msgsize_prop_clause  */
  YYSYMBOL_rcptcount_clause = 324,         /* rcptcount_clause  */
  YYSYMBOL_rcptcount_prop_clause = 325,    /* rcptcount_prop_clause  */
  YYSYMBOL_nodrac = 326,                   /* nodrac  */
  YYSYMBOL_maxpeek = 327,                  /* maxpeek  */
  YYSYMBOL_dnsrbldef = 328,                /* dnsrbldef  */
  YYSYMBOL_dnsrbldefip = 329,              /* dnsrbldefip  */
  YYSYMBOL_dnsrbldefnetblock = 330,        /* dnsrbldefnetblock  */
  YYSYMBOL_macrodef = 331,                 /* macrodef  */
  YYSYMBOL_macrodef_string = 332,          /* macrodef_string  */
  YYSYMBOL_ldapcheckdef = 333,             /* ldapcheckdef  */
  YYSYMBOL_ldapcheckdef_flags = 334,       /* ldapcheckdef_flags  */
  YYSYMBOL_ldapcheckdef_clear = 335,       /* ldapcheckdef_clear  */
  YYSYMBOL_ldapcheckdef_domatch = 336,     /* ldapcheckdef_domatch  */
  YYSYMBOL_ldapcheckdef_noescape = 337,    /* ldapcheckdef_noescape  */
  YYSYMBOL_urlcheckdef = 338,              /* urlcheckdef  */
  YYSYMBOL_urlcheckdef_flags = 339,        /* urlcheckdef_flags  */
  YYSYMBOL_urlcheckdef_postmsg = 340,      /* urlcheckdef_postmsg  */
  YYSYMBOL_urlcheckdef_noencode = 341,     /* urlcheckdef_noencode  */
  YYSYMBOL_urlcheckdef_getprop = 342,      /* urlcheckdef_getprop  */
  YYSYMBOL_urlcheckdef_clear = 343,        /* urlcheckdef_clear  */
  YYSYMBOL_urlcheckdef_fork = 344,         /* urlcheckdef_fork  */
  YYSYMBOL_ldapconfdef = 345,              /* ldapconfdef  */
  YYSYMBOL_ldaptimeout = 346,              /* ldaptimeout  */
  YYSYMBOL_fixldapcheck = 347,             /* fixldapcheck  */
  YYSYMBOL_localaddrdef = 348,             /* localaddrdef  */
  YYSYMBOL_macrodef_regex = 349,           /* macrodef_regex  */
  YYSYMBOL_macrodef_unset = 350,           /* macrodef_unset  */
  YYSYMBOL_clockspec = 351,                /* clockspec  */
  YYSYMBOL_clockspec_item = 352,           /* clockspec_item  */
  YYSYMBOL_listdef = 353,                  /* listdef  */
  YYSYMBOL_email_list = 354,               /* email_list  */
  YYSYMBOL_email_item = 355,               /* email_item  */
  YYSYMBOL_domain_list = 356,              /* domain_list  */
  YYSYMBOL_domain_item = 357,              /* domain_item  */
  YYSYMBOL_qstring_list = 358,             /* qstring_list  */
  YYSYMBOL_qstring_item = 359,             /* qstring_item  */
  YYSYMBOL_addr_list = 360,                /* addr_list  */
  YYSYMBOL_addr_item = 361                 /* addr_item  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   733

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  171
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  191
/* YYNRULES -- Number of rules.  */
#define YYNRULES  467
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  749

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   424


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     170,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   124,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   192,
     202,   212,   229,   247,   252,   257,   266,   271,   276,   284,
     289,   294,   305,   322,   331,   342,   359,   368,   379,   396,
     406,   410,   415,   419,   424,   435,   448,   459,   471,   473,
     477,   479,   481,   483,   485,   487,   489,   491,   493,   495,
     497,   499,   501,   505,   511,   516,   525,   529,   539,   544,
     570,   575,   588,   602,   623,   640,   641,   642,   643,   644,
     645,   646,   647,   650,   668,   686,   704,   719,   734,   749,
     767,   780,   793,   806,   807,   808,   809,   812,   813,   814,
     815,   816,   817,   818,   819,   820,   821,   822,   823,   833,
     843,   844,   845,   846,   847,   848,   849,   850,   853,   862,
     865,   869,   872,   876,   880,   889,   903,   909,   920,   938,
     942,   951,   965,   971,   982,  1000,  1004,  1011,  1019,  1026,
    1034,  1041,  1051,  1054,  1057,  1063,  1066,  1069,  1072,  1078,
    1081,  1084,  1087,  1092,  1097,  1100,  1101,  1104,  1104,  1105,
    1105,  1107,  1108,  1111,  1112,  1113,  1114,  1115,  1116,  1117,
    1118,  1119,  1120,  1121,  1122,  1123,  1124,  1125,  1126,  1127,
    1128,  1129,  1130,  1131,  1132,  1133,  1134,  1135,  1136,  1137,
    1138,  1139,  1140,  1141,  1142,  1143,  1144,  1145,  1146,  1147,
    1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,
    1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,  1166,  1167,
    1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,
    1178,  1179,  1182,  1183,  1186,  1187,  1188,  1189,  1190,  1191,
    1192,  1193,  1194,  1195,  1196,  1197,  1198,  1201,  1204,  1208,
    1219,  1231,  1233,  1235,  1241,  1247,  1253,  1259,  1265,  1272,
    1278,  1284,  1288,  1291,  1295,  1309,  1320,  1331,  1347,  1357,
    1373,  1381,  1384,  1387,  1390,  1393,  1396,  1399,  1402,  1405,
    1408,  1424,  1439,  1447,  1455,  1463,  1465,  1478,  1500,  1508,
    1516,  1519,  1528,  1534,  1543,  1549,  1564,  1581,  1594,  1608,
    1623,  1634,  1645,  1656,  1667,  1678,  1689,  1699,  1709,  1719,
    1729,  1739,  1749,  1759,  1769,  1779,  1789,  1799,  1809,  1820,
    1831,  1844,  1856,  1865,  1871,  1877,  1884,  1893,  1902,  1918,
    1935,  1946,  1956,  1966,  1976,  1986,  1989,  1995,  1995,  1998,
    2012,  2026,  2026,  2026,  2028,  2039,  2054,  2055,  2056,  2057,
    2060,  2070,  2081,  2092,  2108,  2109,  2110,  2111,  2112,  2113,
    2116,  2126,  2136,  2146,  2156,  2167,  2183,  2197,  2206,  2215,
    2217,  2219,  2224,  2235,  2244,  2253,  2254,  2256,  2258,  2260,
    2262,  2264,  2266,  2270,  2278,  2280,  2282,  2284,  2286,  2288,
    2290,  2292,  2294,  2296,  2298,  2300,  2302,  2304,  2306,  2308,
    2312,  2313,  2316,  2317,  2320,  2321,  2324,  2325,  2328,  2329,
    2332,  2338,  2341,  2342,  2345,  2353,  2361,  2375
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TNUMBER", "ADDR",
  "IPADDR", "IP6ADDR", "CIDR", "HELO", "FROM", "RCPT", "EMAIL", "PEER",
  "AUTOWHITE", "GREYLIST", "NOAUTH", "NOACCESSDB", "EXTENDEDREGEX",
  "NOSPF", "QUIET", "TESTMODE", "MULTIRACL", "VERBOSE", "PIDFILE",
  "GLDUMPFILE", "QSTRING", "TDELAY", "SUBNETMATCH", "SUBNETMATCH6",
  "SOCKET", "USER", "NODETACH", "REGEX", "REPORT", "NONE", "DELAYS",
  "NODELAYS", "ALL", "LAZYAW", "GLDUMPFREQ", "GLTIMEOUT", "DOMAIN",
  "DOMAINNAME", "SYNCADDR", "SYNCSRCADDR", "SYNCMAXQLEN", "PORT", "ACL",
  "WHITELIST", "DEFAULT", "STAR", "DELAYEDREJECT", "DB", "NODRAC", "DRAC",
  "DUMP_NO_TIME_TRANSLATION", "LOGEXPIRED", "GLXDELAY", "DNSRBL", "LIST",
  "OPENLIST", "CLOSELIST", "BLACKLIST", "FLUSHADDR", "CODE", "ECODE",
  "MSG", "SM_MACRO", "UNSET", "URLCHECK", "RACL", "DACL", "GLHEADER",
  "BODY", "MAXPEEK", "STAT", "POSTMSG", "FORK", "GETPROP", "CLEAR", "PROP",
  "AUTH", "TLS", "SPF", "MSGSIZE", "RCPTCOUNT", "OP", "NO", "SLASH",
  "MINUS", "COMMA", "TIME", "GEOIPDB", "GEOIPV6DB", "GEOIP", "PASS",
  "FAIL", "SOFTFAIL", "NEUTRAL", "UNKNWON", "ERROR", "SELF", "SPF_STATUS",
  "LDAPCONF", "LDAPCHECK", "LOGFAC", "LOGFAC_KERN", "LOGFAC_USER",
  "LOGFAC_MAIL", "LOGFAC_DAEMON", "LOGFAC_AUTH", "LOGFAC_SYSLOG",
  "LOGFAC_LPR", "LOGFAC_NEWS", "LOGFAC_UUCP", "LOGFAC_CRON",
  "LOGFAC_AUTHPRIV", "LOGFAC_FTP", "LOGFAC_LOCAL0", "LOGFAC_LOCAL1",
  "LOGFAC_LOCAL2", "LOGFAC_LOCAL3", "LOGFAC_LOCAL4", "LOGFAC_LOCAL5",
  "LOGFAC_LOCAL6", "LOGFAC_LOCAL7", "P0F", "P0FSOCK", "DKIMCHECK",
  "SPAMDSOCK", "SPAMDSOCKT", "SPAMD", "DOMAINEXACT", "ADDHEADER", "NOLOG",
  "LDAPBINDDN", "LDAPBINDPW", "TARPIT", "TARPIT_SCOPE", "SESSION",
  "COMMAND", "MX", "RATELIMIT", "KEY", "DOMATCH", "DATA", "LOCALADDR",
  "ADDFOOTER", "CONTINUE", "FIXLDAPCHECK", "SUBJTAG", "NOENCODE",
  "NOESCAPE", "TSIG", "NSUPDATE", "SERVERS", "RNAME", "RVALUE", "TTL",
  "CLASS", "TYPE", "UNBRACKET", "SET", "RSET", "EQSET", "INCSET", "DECSET",
  "LOG", "RAWFROM", "GEOIP2DB", "'\\n'", "$accept", "lines", "netblock",
  "fromaddr", "rawfromaddr", "rcptaddr", "fromregex", "rawfromregex",
  "rcptregex", "domainaddr", "domainregex", "peeraddr", "autowhite",
  "greylist", "tarpit", "tarpit_scope", "verbose",
  "dump_no_time_translation", "logexpired", "quiet", "noauth", "multiracl",
  "noaccessdb", "extendedregex", "unbracket", "nospf", "delayedreject",
  "testmode", "nodetach", "lazyaw", "domainexact", "pidfile", "dumpfile",
  "subnetmatch", "subnetmatch6", "socket", "user", "p0fsockdef",
  "spamdsockdef", "tsigdef", "nsupdatedef", "nsupdatedefitems",
  "nsupdatedefservers", "nsupdatedefrname", "nsupdatedefrvalue",
  "nsupdatedefttl", "nsupdatedefclass", "nsupdatedeftype",
  "nsupdatedeftsig", "geoipdb", "geoipv6db", "geoip2db", "report",
  "logfac", "statdef", "dumpfreq", "timeout", "syncaddr", "syncsrcaddr",
  "syncmaxqlen", "ratelimitdef", "access_list", "rcpt_access_list",
  "data_access_list", "id", "acl_entry", "acl_default_entry",
  "acl_plain_entry", "acl_clauses", "acl_clause", "acl_values",
  "acl_value", "greylist_value", "autowhite_value", "tarpit_scope_value",
  "flush_value", "nolog_value", "code_value", "ecode_value", "msg_value",
  "report_value", "addheader_value", "addfooter_value", "subjtag_value",
  "maxpeek_value", "no_clause", "time_clause", "p0f_clause",
  "p0fregex_clause", "spamd_clause", "spamd_score_clause",
  "spamd_score_prop_clause", "geoip_clause", "helo_clause",
  "heloregex_clause", "fromaddr_clause", "rawfromaddr_clause",
  "fromregex_clause", "rawfromregex_clause", "rcptaddr_clause",
  "rcptregex_clause", "domainaddr_clause", "domainregex_clause",
  "dnsrbl_clause", "mx_clause", "macro_clause", "ratelimit_clause",
  "header_clause", "headerregex_clause", "tarpit_clause",
  "nsupdate_clause", "log_clause", "body_clause", "bodyregex_clause",
  "auth_clause", "authregex_clause", "tls_clause", "tlsregex_clause",
  "spf_clause", "spf_compat_clause", "dkim_clause", "urlcheck_clause",
  "ldapcheck_clause", "eqsetstring_clause", "eqrsetstring_clause",
  "incsetstring_clause", "incrsetstring_clause", "decsetstring_clause",
  "decrsetstring_clause", "eqsetnum_clause", "eqrsetnum_clause",
  "incsetnum_clause", "incrsetnum_clause", "decsetnum_clause",
  "decrsetnum_clause", "eqsetprop_clause", "eqrsetprop_clause",
  "incsetprop_clause", "incrsetprop_clause", "decsetprop_clause",
  "decrsetprop_clause", "propstr_clause", "propglob_clause",
  "propnum_clause", "propprop_clause", "propregex_clause",
  "bodyprop_clause", "headerprop_clause", "list_clause", "netblock_clause",
  "dracdb", "msgsize_clause", "msgsize_prop_clause", "rcptcount_clause",
  "rcptcount_prop_clause", "nodrac", "maxpeek", "dnsrbldef", "dnsrbldefip",
  "dnsrbldefnetblock", "macrodef", "macrodef_string", "ldapcheckdef",
  "ldapcheckdef_flags", "ldapcheckdef_clear", "ldapcheckdef_domatch",
  "ldapcheckdef_noescape", "urlcheckdef", "urlcheckdef_flags",
  "urlcheckdef_postmsg", "urlcheckdef_noencode", "urlcheckdef_getprop",
  "urlcheckdef_clear", "urlcheckdef_fork", "ldapconfdef", "ldaptimeout",
  "fixldapcheck", "localaddrdef", "macrodef_regex", "macrodef_unset",
  "clockspec", "clockspec_item", "listdef", "email_list", "email_item",
  "domain_list", "domain_item", "qstring_list", "qstring_item",
  "addr_list", "addr_item", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-541)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -541,     6,  -541,   190,   392,   393,   164,   179,   187,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,   -11,    -8,    25,
      31,    53,    83,  -541,   374,  -541,   298,   324,    55,   148,
     159,   103,   167,  -541,  -541,    34,  -541,  -541,   155,   160,
     166,   168,   217,   217,   201,   226,   229,   234,   268,   271,
     328,   283,   200,  -541,   361,   335,   301,   265,  -541,   315,
     342,  -541,   457,   352,  -541,   119,   253,   263,   285,   291,
     295,   299,   311,   313,   314,   317,   318,   321,   325,   330,
     332,   333,   334,   336,   337,   339,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   353,   354,   355,   356,   357,
     358,   359,   360,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   375,   376,   377,   378,   379,   380,
     381,   382,   383,  -541,  -541,   384,  -541,   385,   387,   388,
     389,   390,  -541,  -541,   394,   478,   487,  -541,  -541,  -541,
    -541,   458,   465,   468,  -541,  -541,  -541,  -541,  -541,   494,
    -541,  -541,   498,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,   464,   466,   476,   485,   497,   510,
    -541,   264,   264,   264,   486,   502,   302,   536,   537,  -541,
      -7,    -6,  -541,   538,  -541,  -541,   184,   540,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
     541,  -541,  -541,  -541,  -541,    -5,  -541,  -541,   542,   508,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
     373,   386,   404,  -541,  -541,   566,   567,   568,   569,   570,
     571,    61,   272,   139,   196,   297,    50,   495,   -12,   551,
      33,   183,   189,   198,    87,   331,   340,   475,   492,   493,
    -541,   129,   225,   555,   439,   479,   496,   557,   577,   560,
     561,   507,   509,   563,   220,  -541,  -541,  -541,   153,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,   585,   531,   532,   533,   534,   535,   539,   543,
     544,   545,   546,   547,   548,   549,   550,   552,   553,  -541,
     251,   593,   264,   264,   264,   264,   264,   264,   264,   264,
    -541,  -541,   572,   462,  -541,  -541,   597,   598,   599,   586,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,   607,   608,   411,  -541,  -541,   310,  -541,
    -541,   461,  -541,  -541,   461,  -541,  -541,   213,   590,   592,
     594,  -541,   596,   600,   601,   615,   602,  -541,   338,   603,
     604,    50,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,   605,  -541,   310,  -541,
    -541,   310,  -541,   310,  -541,  -541,   310,  -541,  -541,  -541,
     310,  -541,  -541,  -541,     8,  -541,  -541,   310,  -541,  -541,
     310,  -541,     9,    37,   391,   554,   310,    81,   529,  -541,
     310,  -541,  -541,  -541,   310,  -541,    40,  -541,  -541,  -541,
    -541,   249,   255,  -541,  -541,  -541,   461,  -541,    50,   616,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,   606,   -70,   556,   558,   559,  -541,   -30,
    -541,  -541,   617,   625,   131,  -541,  -541,  -541,   214,  -541,
    -541,  -541,   107,  -541,   140,  -541,  -541,   256,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,   562,  -541,  -541,  -541,
    -541,  -541,  -541,   216,   267,   277,   293,   309,  -541,  -541,
     327,   341,  -541,  -541,  -541,  -541,   619,   630,   631,   397,
      81,    81,   431,   435,  -541,  -541,    65,    66,    67,    69,
      76,    97,   221,  -541,    27,   499,  -541,  -541,  -541,  -541,
    -541,  -541,   610,   611,   612,  -541,   614,   618,   620,   623,
     624,   637,   638,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,   646,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
     565,  -541,  -541,    81,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,   575,  -541,   626,   512,   513,   514,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,   655,    81,  -541,  -541,
    -541,   634,   635,   636,  -541,  -541,  -541,  -541,  -541
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
      68,     0,     1,     0,     0,     0,     0,     0,     0,   102,
     104,   105,   107,   101,   109,   103,    98,     0,     0,     0,
       0,     0,     0,   110,     0,   111,     0,     0,     0,     0,
       0,     0,     0,   108,   385,     0,    99,   100,     0,     0,
       0,     0,   204,   204,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   112,     0,     0,     0,     0,   420,     0,
       0,   106,     0,     0,    67,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   387,   388,     0,   391,     0,     0,     0,
       0,     0,   392,   393,     0,    70,    72,    73,    76,    75,
      78,    87,    88,    89,    91,    90,    93,    92,   113,   114,
     116,   117,   118,   120,   143,   144,   145,   146,   170,   169,
     172,   171,    80,    79,   174,   175,   173,   180,   181,   179,
     185,     0,     0,     0,     0,     0,     0,     0,     0,   203,
       0,     0,   386,     0,   140,   141,   419,     0,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   121,
       0,    95,    94,    96,    97,     0,   421,   422,     0,     0,
      74,    77,   142,     2,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    23,    24,    25,    26,    12,    13,    51,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    36,
      37,    64,    27,    28,    29,    30,    31,    32,    59,    60,
      61,    62,    33,    34,    35,    38,    39,    40,    41,    42,
      43,    44,    65,    66,    45,    46,    47,    48,    50,    49,
      52,    53,    55,    54,    56,    57,    58,    63,    69,    71,
       0,     0,     0,   115,   119,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   208,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   346,     0,     0,
     312,     0,     0,     0,     0,     0,   316,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   205,   206,   210,   211,
     266,   267,   248,   249,   276,   277,   278,   268,   213,   214,
     215,   217,   216,   218,   219,   220,   221,   222,   224,   225,
     226,   227,   251,   252,   279,   280,   281,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   269,   270,   272,   273,
     271,   274,   275,   250,   223,   262,   263,   264,   265,   193,
     194,   380,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     168,   418,     0,   416,   399,   122,     0,     0,     0,     0,
     132,    84,    81,    85,    82,    86,    83,   177,   178,   176,
     183,   184,   182,   377,   379,     0,   320,   321,     0,   322,
     324,     0,   326,   327,     0,   329,   328,     0,     0,     0,
       0,   301,     0,     0,     0,     0,     0,   302,     0,     0,
       0,   207,   282,   284,   285,   286,   291,   292,   287,   288,
     289,   290,   293,   294,   295,   296,     0,   330,     0,   375,
     332,     0,   348,     0,   334,   335,     0,   374,   339,   340,
       0,   373,   368,   372,     0,   341,   342,     0,   343,   344,
       0,   345,     0,     0,   427,   431,     0,     0,   426,   319,
       0,   349,   314,   315,     0,   347,     0,   336,   331,   333,
     337,     0,     0,   338,   323,   325,     0,   212,   209,   389,
     394,   423,   424,   409,   195,   196,   197,   198,   199,   200,
     201,   202,   417,     0,   395,     0,     0,     0,   123,     0,
     376,   378,   465,   467,     0,   462,   460,   461,     0,   458,
     452,   453,     0,   450,     0,   457,   456,     0,   454,   298,
     306,   297,   303,   304,   305,   311,   307,   299,   300,   309,
     310,   283,   369,     0,     0,     0,     0,     0,   370,   371,
       0,     0,   381,   382,   383,   384,     0,     0,     0,     0,
       0,     0,     0,     0,   317,   318,     0,     0,     0,     0,
       0,     0,     0,   390,   403,     0,   400,   401,   402,   396,
     397,   398,     0,     0,     0,   124,     0,     0,     0,     0,
       0,     0,     0,   125,   126,   127,   128,   129,   130,   131,
     464,   466,   444,   463,   434,   459,   435,   451,   437,   438,
     455,     0,   439,   443,   440,   442,   441,   445,   446,   428,
     429,   432,   447,     0,   425,   448,   449,   356,   350,   362,
     358,   352,   364,   360,   354,   366,   357,   351,   363,   359,
     353,   365,   361,   355,   367,   436,   410,   414,   412,   411,
     404,   406,   405,   408,     0,   186,   188,   190,   139,   133,
     134,   135,   136,   137,   138,   308,     0,     0,   413,   407,
     415,     0,     0,     0,   430,   313,   187,   189,   191
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,   621,  -172,  -541,  -541,  -541,   329,
     395,  -487,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,   489,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,  -541,
    -535,  -541,  -541,  -471,  -540,  -541,    71,   -54,  -235,  -541,
      78
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   579,   663,   664,   665,   666,   667,   668,   669,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   180,   335,   336,   337,   338,   339,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     119,   405,   406,   407,   408,   120,   121,   122,   123,   124,
     125,   126,   127,   574,   649,   650,   651,   128,   644,   720,
     721,   722,   739,   723,   129,   443,   130,   131,   132,   133,
     537,   538,   134,   592,   593,   597,   598,   588,   589,   584,
     585
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     409,   410,   630,   594,   611,   446,     2,   432,   436,   646,
       3,   618,   622,   507,   148,     4,     5,   149,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,   655,   150,    19,    20,    21,    22,    23,   151,    24,
     624,   433,   437,   634,    25,    26,    27,    28,   508,    29,
      30,    31,   677,    32,   677,   434,   438,    33,   510,    34,
      35,    36,    37,   478,    38,    39,   463,   464,   697,   700,
     703,   611,   706,    40,   647,    41,    42,    43,   152,   709,
      44,    45,   648,   479,   534,   642,   174,   162,   619,   623,
     698,   701,   704,   511,   707,   693,   694,   163,    46,    47,
     712,   710,   677,   716,   717,   718,   170,   480,   153,    48,
      49,    50,   522,   481,   482,   483,   484,   625,   590,   523,
     635,   465,   713,   656,   485,   657,   658,   659,   660,   661,
     662,   535,   534,    51,   447,    52,   582,   583,    53,   591,
     448,   435,   439,    54,    55,   699,   702,   705,    56,   708,
     469,   590,    57,   164,   165,    58,   711,   301,   737,    59,
      60,   302,   303,   304,   167,   168,   478,    61,   676,   141,
     142,   470,   591,   524,    62,    63,    64,   714,   719,   535,
     175,   171,   144,   486,   487,   176,   479,   441,   488,   536,
     146,   177,   672,   178,   305,   135,   136,   489,   166,   471,
     490,   678,   745,   307,   182,   145,   143,   472,   512,   169,
     480,   308,   309,   147,   514,   172,   481,   482,   483,   484,
     310,   515,   311,   518,   442,   312,   313,   485,   473,   173,
     519,   554,   590,   314,   315,   316,   317,   318,   319,   586,
     320,   586,   179,   513,   321,   595,   587,   322,   587,   516,
     539,   183,   555,   591,   184,   596,   474,   323,   520,   185,
     564,   565,   566,   567,   568,   569,   570,   571,   301,   517,
     216,   217,   302,   303,   304,   674,   560,   682,   521,   324,
     556,   325,   715,   561,   326,   540,   486,   487,   595,   223,
     327,   488,   586,   186,   328,   329,   187,   466,   596,   587,
     489,   158,   586,   490,   467,   305,   413,   330,   209,   587,
     414,   415,   416,   306,   307,   331,   332,   679,   586,   562,
     333,   334,   308,   309,   159,   587,   215,   160,   683,   475,
     210,   310,   468,   311,   586,   586,   312,   313,   684,   476,
     218,   587,   587,   417,   314,   315,   316,   317,   318,   319,
     161,   320,   586,   675,   685,   321,   525,   477,   322,   587,
     418,   309,   188,   526,   211,   528,   586,   219,   323,   419,
     686,   420,   529,   587,   421,   422,   451,   222,   675,   675,
     675,   675,   675,   423,   424,   675,   675,   212,   687,   453,
     324,   527,   325,   425,   675,   326,   426,   675,   675,   452,
     530,   327,   688,   137,   139,   328,   329,   455,   154,   155,
     156,   157,   454,   636,   637,   638,   582,   583,   330,   639,
     640,   641,   586,   224,   138,   140,   331,   332,   427,   587,
     456,   333,   334,   225,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   613,   226,   586,   614,   692,   615,
     586,   227,   616,   587,   542,   228,   617,   587,   220,   229,
     428,   543,   590,   620,   213,   214,   621,   607,   608,   626,
     627,   230,   629,   231,   232,   288,   632,   233,   234,   221,
     633,   235,   695,   591,   289,   236,   696,   293,   290,   544,
     237,   294,   238,   239,   240,   291,   241,   242,   292,   243,
     295,   411,   296,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   297,   253,   254,   255,   256,   257,   258,   259,
     260,   298,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   299,   412,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   300,   283,   284,   285,
     286,   430,   431,   440,   287,   444,   445,   449,   450,   457,
     458,   459,   460,   461,   462,   506,   509,   531,   532,   533,
     541,   545,   546,   547,   548,   549,   550,   551,   553,   552,
     559,   465,   468,   471,   474,   477,   563,   573,   572,   508,
     575,   576,   577,   511,   513,   516,   520,   527,   530,   536,
     540,   578,   544,   556,   580,   581,   599,   600,   605,   631,
     601,   602,   689,   643,   670,   603,   604,   606,   609,   610,
     612,   645,   671,   690,   691,   724,   725,   726,   727,   728,
     733,   734,   628,   729,   652,   730,   653,   654,   731,   735,
     732,   740,   681,   736,   738,   741,   742,   743,   744,   746,
     747,   748,   673,     0,   181,   429,     0,   557,   680,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   558
};

static const yytype_int16 yycheck[] =
{
     172,   173,   537,   474,   491,    10,     0,    14,    14,    79,
       4,     3,     3,    25,    25,     9,    10,    25,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    61,     7,    27,    28,    29,    30,    31,     7,    33,
       3,    48,    48,     3,    38,    39,    40,    41,    60,    43,
      44,    45,   592,    47,   594,    62,    62,    51,    25,    53,
      54,    55,    56,    13,    58,    59,     5,     6,     3,     3,
       3,   558,     3,    67,   144,    69,    70,    71,    25,     3,
      74,    75,   152,    33,     3,   556,    52,    32,    80,    80,
      25,    25,    25,    60,    25,   630,   631,    42,    92,    93,
       3,    25,   642,    76,    77,    78,     3,    57,    25,   103,
     104,   105,    25,    63,    64,    65,    66,    80,    11,    32,
      80,    60,    25,   153,    74,   155,   156,   157,   158,   159,
     160,    50,     3,   127,   139,   129,     5,     6,   132,    32,
     145,   148,   148,   137,   138,    80,    80,    80,   142,    80,
      11,    11,   146,     5,     6,   149,    80,     4,   693,   153,
     154,     8,     9,    10,     5,     6,    13,   161,    61,     5,
       6,    32,    32,    86,   168,   169,   170,    80,   151,    50,
      25,    14,     3,   133,   134,    25,    33,     3,   138,    60,
       3,    25,    61,    25,    41,     5,     6,   147,    50,    60,
     150,    61,   737,    50,     3,    26,    42,    11,    25,    50,
      57,    58,    59,    26,    25,    48,    63,    64,    65,    66,
      67,    32,    69,    25,    40,    72,    73,    74,    32,    62,
      32,    11,    11,    80,    81,    82,    83,    84,    85,    25,
      87,    25,    25,    60,    91,    32,    32,    94,    32,    60,
      25,    25,    32,    32,    25,    42,    60,   104,    60,    25,
     432,   433,   434,   435,   436,   437,   438,   439,     4,    80,
       5,     6,     8,     9,    10,    61,    25,    61,    80,   126,
      60,   128,    61,    32,   131,    60,   133,   134,    32,   170,
     137,   138,    25,    25,   141,   142,    25,    25,    42,    32,
     147,     3,    25,   150,    32,    41,     4,   154,    25,    32,
       8,     9,    10,    49,    50,   162,   163,    61,    25,    68,
     167,   168,    58,    59,    26,    32,    25,     3,    61,    32,
     130,    67,    60,    69,    25,    25,    72,    73,    61,    42,
      25,    32,    32,    41,    80,    81,    82,    83,    84,    85,
      26,    87,    25,   588,    61,    91,    25,    60,    94,    32,
      58,    59,    34,    32,     3,    25,    25,    25,   104,    67,
      61,    69,    32,    32,    72,    73,     3,    25,   613,   614,
     615,   616,   617,    81,    82,   620,   621,    26,    61,     3,
     126,    60,   128,    91,   629,   131,    94,   632,   633,    26,
      60,   137,    61,    11,    11,   141,   142,     3,    34,    35,
      36,    37,    26,   164,   165,   166,     5,     6,   154,   164,
     165,   166,    25,   170,    32,    32,   162,   163,   126,    32,
      26,   167,   168,   170,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   508,   170,    25,   511,    61,   513,
      25,   170,   516,    32,    25,   170,   520,    32,    11,   170,
     168,    32,    11,   527,   139,   140,   530,   139,   140,    88,
      89,   170,   536,   170,   170,     7,   540,   170,   170,    32,
     544,   170,    61,    32,     7,   170,    61,     3,    40,    60,
     170,     3,   170,   170,   170,    40,   170,   170,    40,   170,
      46,    25,    46,   170,   170,   170,   170,   170,   170,   170,
     170,   170,    46,   170,   170,   170,   170,   170,   170,   170,
     170,    46,   170,   170,   170,   170,   170,   170,   170,   170,
     170,   170,   170,    46,    42,   170,   170,   170,   170,   170,
     170,   170,   170,   170,   170,   170,    46,   170,   170,   170,
     170,    25,    25,    25,   170,    25,    25,    25,    60,     3,
       3,     3,     3,     3,     3,    80,    25,   102,    86,    86,
      25,   102,    86,    26,     7,    25,    25,    80,    25,    80,
       5,    60,    60,    60,    60,    60,     3,   135,    26,    60,
       3,     3,     3,    60,    60,    60,    60,    60,    60,    60,
      60,    25,    60,    60,     7,     7,    26,    25,     3,    90,
      26,    25,     3,     7,     7,    25,    25,    25,    25,    25,
      25,    25,     7,     3,     3,   136,    26,    26,    26,    25,
       3,     3,    88,    25,    88,    25,    88,    88,    25,     3,
      26,    25,    90,    88,    79,   143,   143,   143,     3,    25,
      25,    25,   584,    -1,    43,   176,    -1,   338,   597,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   338
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   172,     0,     4,     9,    10,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    27,
      28,    29,    30,    31,    33,    38,    39,    40,    41,    43,
      44,    45,    47,    51,    53,    54,    55,    56,    58,    59,
      67,    69,    70,    71,    74,    75,    92,    93,   103,   104,
     105,   127,   129,   132,   137,   138,   142,   146,   149,   153,
     154,   161,   168,   169,   170,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   321,
     326,   327,   328,   329,   330,   331,   332,   333,   338,   345,
     347,   348,   349,   350,   353,     5,     6,    11,    32,    11,
      32,     5,     6,    42,     3,    26,     3,    26,    25,    25,
       7,     7,    25,    25,    34,    35,    36,    37,     3,    26,
       3,    26,    32,    42,     5,     6,    50,     5,     6,    50,
       3,    14,    48,    62,    52,    25,    25,    25,    25,    25,
     235,   235,     3,    25,    25,    25,    25,    25,    34,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,    25,
     130,     3,    26,   139,   140,    25,     5,     6,    25,    25,
      11,    32,    25,   170,   170,   170,   170,   170,   170,   170,
     170,   170,   170,   170,   170,   170,   170,   170,   170,   170,
     170,   170,   170,   170,   170,   170,   170,   170,   170,   170,
     170,   170,   170,   170,   170,   170,   170,   170,   170,   170,
     170,   170,   170,   170,   170,   170,   170,   170,   170,   170,
     170,   170,   170,   170,   170,   170,   170,   170,   170,   170,
     170,   170,   170,   170,   170,   170,   170,   170,     7,     7,
      40,    40,    40,     3,     3,    46,    46,    46,    46,    46,
      46,     4,     8,     9,    10,    41,    49,    50,    58,    59,
      67,    69,    72,    73,    80,    81,    82,    83,    84,    85,
      87,    91,    94,   104,   126,   128,   131,   137,   141,   142,
     154,   162,   163,   167,   168,   236,   237,   238,   239,   240,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   322,   323,   324,   325,   236,
     236,    25,    42,     4,     8,     9,    10,    41,    58,    67,
      69,    72,    73,    81,    82,    91,    94,   126,   168,   319,
      25,    25,    14,    48,    62,   148,    14,    48,    62,   148,
      25,     3,    40,   346,    25,    25,    10,   139,   145,    25,
      60,     3,    26,     3,    26,     3,    26,     3,     3,     3,
       3,     3,     3,     5,     6,    60,    25,    32,    60,    11,
      32,    60,    11,    32,    60,    32,    42,    60,    13,    33,
      57,    63,    64,    65,    66,    74,   133,   134,   138,   147,
     150,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,    80,    25,    60,    25,
      25,    60,    25,    60,    25,    32,    60,    80,    25,    32,
      60,    80,    25,    32,    86,    25,    32,    60,    25,    32,
      60,   102,    86,    86,     3,    50,    60,   351,   352,    25,
      60,    25,    25,    32,    60,   102,    86,    26,     7,    25,
      25,    80,    80,    25,    11,    32,    60,   240,   241,     5,
      25,    32,    68,     3,   236,   236,   236,   236,   236,   236,
     236,   236,    26,   135,   334,     3,     3,     3,    25,   212,
       7,     7,     5,     6,   360,   361,    25,    32,   358,   359,
      11,    32,   354,   355,   354,    32,    42,   356,   357,    26,
      25,    26,    25,    25,    25,     3,    25,   139,   140,    25,
      25,   242,    25,   358,   358,   358,   358,   358,     3,    80,
     358,   358,     3,    80,     3,    80,    88,    89,    88,   358,
     351,    90,   358,   358,     3,    80,   164,   165,   166,   164,
     165,   166,   354,     7,   339,    25,    79,   144,   152,   335,
     336,   337,    88,    88,    88,    61,   153,   155,   156,   157,
     158,   159,   160,   213,   214,   215,   216,   217,   218,   219,
       7,     7,    61,   361,    61,   359,    61,   355,    61,    61,
     357,    90,    61,    61,    61,    61,    61,    61,    61,     3,
       3,     3,    61,   351,   351,    61,    61,     3,    25,    80,
       3,    25,    80,     3,    25,    80,     3,    25,    80,     3,
      25,    80,     3,    25,    80,    61,    76,    77,    78,   151,
     340,   341,   342,   344,   136,    26,    26,    26,    25,    25,
      25,    25,    26,     3,     3,     3,    88,   351,    79,   343,
      25,   143,   143,   143,     3,   351,    25,    25,    25
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   171,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   172,   172,   172,   172,   172,   172,   173,
     173,   173,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   182,   182,   182,   182,   182,   182,   182,   182,
     183,   183,   184,   184,   185,   185,   186,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   203,   204,   205,   206,   206,
     207,   208,   209,   210,   211,   212,   212,   212,   212,   212,
     212,   212,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   223,   223,   223,   224,   224,   224,
     224,   224,   224,   224,   224,   224,   224,   224,   224,   224,
     224,   224,   224,   224,   224,   224,   224,   224,   225,   226,
     226,   227,   227,   228,   228,   228,   228,   228,   228,   229,
     229,   229,   229,   229,   229,   230,   231,   231,   231,   231,
     231,   231,   232,   232,   232,   233,   233,   233,   233,   234,
     234,   234,   234,   235,   235,   236,   236,   237,   237,   238,
     238,   239,   239,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
     240,   240,   241,   241,   242,   242,   242,   242,   242,   242,
     242,   242,   242,   242,   242,   242,   242,   243,   244,   245,
     245,   246,   247,   248,   249,   250,   251,   252,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   320,   320,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   328,   329,
     330,   331,   331,   331,   332,   333,   334,   334,   334,   334,
     335,   336,   337,   338,   339,   339,   339,   339,   339,   339,
     340,   341,   342,   343,   344,   345,   345,   346,   346,   346,
     347,   348,   348,   349,   350,   351,   351,   352,   352,   352,
     352,   352,   352,   353,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     354,   354,   355,   355,   356,   356,   357,   357,   358,   358,
     359,   359,   360,   360,   361,   361,   361,   361
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     0,     3,
       2,     3,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     4,     4,     4,     4,     4,     4,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     3,     2,     2,     2,     3,
       2,     2,     3,     4,     5,     2,     2,     2,     2,     2,
       2,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     2,     2,     2,     2,     2,     4,     4,     4,     2,
       2,     2,     4,     4,     4,     2,     6,     8,     6,     8,
       6,     8,     3,     3,     3,     4,     4,     4,     4,     4,
       4,     4,     4,     1,     0,     1,     1,     2,     1,     2,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     1,     1,     2,     2,     2,     2,     2,     4,     2,
       2,     2,     1,     6,     2,     2,     1,     3,     3,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     2,     2,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     2,     3,
       3,     3,     2,     2,     2,     2,     3,     2,     3,     2,
       3,     3,     3,     3,     3,     1,     2,     1,     1,     4,
       5,     1,     1,     1,     4,     4,     2,     2,     2,     0,
       1,     1,     1,     5,     2,     2,     2,     3,     2,     0,
       1,     1,     1,     1,     1,     7,     3,     2,     1,     0,
       1,     2,     2,     4,     4,     3,     1,     1,     3,     3,
       5,     1,     3,     3,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       1,     2,     1,     1,     1,     2,     1,     1,     1,     2,
       1,     1,     1,     2,     2,     1,     2,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 69: /* netblock: ADDR IPADDR CIDR  */
#line 192 "conf_yacc.y"
                                {
			struct acl_netblock_data and;

			and.addr = SA(&(yyvsp[-1].ipaddr));
			and.salen = sizeof(struct sockaddr_in);
			and.cidr = (yyvsp[0].cidr);

			acl_add_clause(AC_NETBLOCK, &and);
			acl_register_entry_first(AS_RCPT, A_WHITELIST);
		}
#line 2525 "y.tab.c"
    break;

  case 70: /* netblock: ADDR IPADDR  */
#line 202 "conf_yacc.y"
                                {
			struct acl_netblock_data and;

			and.addr = SA(&(yyvsp[0].ipaddr));
			and.salen = sizeof(struct sockaddr_in);
			and.cidr = 32;

			acl_add_clause(AC_NETBLOCK, &and);
			acl_register_entry_first(AS_RCPT, A_WHITELIST);
		}
#line 2540 "y.tab.c"
    break;

  case 71: /* netblock: ADDR IP6ADDR CIDR  */
#line 212 "conf_yacc.y"
                                 {
#ifdef AF_INET6
			struct acl_netblock_data and;

			and.addr = SA(&(yyvsp[-1].ip6addr));
			and.salen = sizeof(struct sockaddr_in6);
			and.cidr = (yyvsp[0].cidr);

			acl_add_clause(AC_NETBLOCK, &and);
			acl_register_entry_first(AS_RCPT, A_WHITELIST);
#else
			acl_drop();
			mg_log(LOG_INFO,
			    "IPv6 is not supported, ignore line %d",
			    conf_line);
#endif
		}
#line 2562 "y.tab.c"
    break;

  case 72: /* netblock: ADDR IP6ADDR  */
#line 229 "conf_yacc.y"
                                {
#ifdef AF_INET6
			struct acl_netblock_data and;

			and.addr = SA(&(yyvsp[0].ip6addr));
			and.salen = sizeof(struct sockaddr_in6);
			and.cidr = 128;

			acl_add_clause(AC_NETBLOCK, &and);
			acl_register_entry_first(AS_RCPT, A_WHITELIST);
#else
			acl_drop();
			mg_log(LOG_INFO,
			    "IPv6 is not supported, ignore line %d",
			    conf_line);
#endif
		}
#line 2584 "y.tab.c"
    break;

  case 73: /* fromaddr: FROM EMAIL  */
#line 247 "conf_yacc.y"
                                {
			acl_add_clause(AC_FROM, (yyvsp[0].email));
			acl_register_entry_first(AS_RCPT, A_WHITELIST);
		}
#line 2593 "y.tab.c"
    break;

  case 74: /* rawfromaddr: RAWFROM EMAIL  */
#line 252 "conf_yacc.y"
                                {
			acl_add_clause(AC_RAWFROM, (yyvsp[0].email));
			acl_register_entry_first(AS_RCPT, A_WHITELIST);
		}
#line 2602 "y.tab.c"
    break;

  case 75: /* rcptaddr: RCPT EMAIL  */
#line 257 "conf_yacc.y"
                                {
			acl_add_clause(AC_RCPT, (yyvsp[0].email));
			if (conf.c_testmode)
				acl_register_entry_first(AS_RCPT, A_GREYLIST);
			else
				acl_register_entry_first(AS_RCPT, A_WHITELIST);
		}
#line 2614 "y.tab.c"
    break;

  case 76: /* fromregex: FROM REGEX  */
#line 266 "conf_yacc.y"
                                {
			acl_add_clause(AC_FROM_RE, (yyvsp[0].regex));
			acl_register_entry_first(AS_RCPT, A_WHITELIST);
		}
#line 2623 "y.tab.c"
    break;

  case 77: /* rawfromregex: RAWFROM REGEX  */
#line 271 "conf_yacc.y"
                                {
			acl_add_clause(AC_RAWFROM_RE, (yyvsp[0].regex));
			acl_register_entry_first(AS_RCPT, A_WHITELIST);
		}
#line 2632 "y.tab.c"
    break;

  case 78: /* rcptregex: RCPT REGEX  */
#line 276 "conf_yacc.y"
                                {
			acl_add_clause(AC_RCPT_RE, (yyvsp[0].regex));
			if (conf.c_testmode)
				acl_register_entry_first(AS_RCPT, A_GREYLIST);
			else
				acl_register_entry_first(AS_RCPT, A_WHITELIST);
		}
#line 2644 "y.tab.c"
    break;

  case 79: /* domainaddr: DOMAIN DOMAINNAME  */
#line 284 "conf_yacc.y"
                                  {
			acl_add_clause(AC_DOMAIN, (yyvsp[0].domainname));
			acl_register_entry_first(AS_RCPT, A_WHITELIST);
		}
#line 2653 "y.tab.c"
    break;

  case 80: /* domainregex: DOMAIN REGEX  */
#line 289 "conf_yacc.y"
                                 {
			acl_add_clause(AC_DOMAIN_RE, (yyvsp[0].regex));
			acl_register_entry_first(AS_RCPT, A_WHITELIST);
		}
#line 2662 "y.tab.c"
    break;

  case 81: /* peeraddr: PEER IPADDR GLTIMEOUT TDELAY  */
#line 294 "conf_yacc.y"
                                                {
			char addr[IPADDRSTRLEN];

			if (IP4TOSTRING((yyvsp[-2].ipaddr), addr) == NULL) {
				mg_log(LOG_ERR,
				    "invalid IPv4 address line %d",
				    conf_line);
				exit(EX_DATAERR);
			}
			peer_add(addr, (time_t)humanized_atoi((yyvsp[0].delay)));
		}
#line 2678 "y.tab.c"
    break;

  case 82: /* peeraddr: PEER IP6ADDR GLTIMEOUT TDELAY  */
#line 305 "conf_yacc.y"
                                                {
#ifdef AF_INET6
			char addr[IPADDRSTRLEN];

			if (IP6TOSTRING((yyvsp[-2].ip6addr), addr) == NULL) {
				mg_log(LOG_ERR, 
				    "invalid IPv6 address line %d",
				    conf_line);
				exit(EX_DATAERR);
			}
			peer_add(addr, (time_t)humanized_atoi((yyvsp[0].delay)));
#else
			mg_log(LOG_INFO,
			    "IPv6 is not supported, ignore line %d",
			    conf_line);
#endif
		}
#line 2700 "y.tab.c"
    break;

  case 83: /* peeraddr: PEER DOMAINNAME GLTIMEOUT TDELAY  */
#line 322 "conf_yacc.y"
                                                        {
#ifdef HAVE_GETADDRINFO
			peer_add((yyvsp[-2].domainname), (time_t)humanized_atoi((yyvsp[0].delay)));
#else
			mg_log(LOG_INFO,
			    "FQDN in peer is not supported, "
			    "ignore line %d", conf_line);
#endif
		}
#line 2714 "y.tab.c"
    break;

  case 84: /* peeraddr: PEER IPADDR GLTIMEOUT TNUMBER  */
#line 331 "conf_yacc.y"
                                                {
			char addr[IPADDRSTRLEN];

			if (IP4TOSTRING((yyvsp[-2].ipaddr), addr) == NULL) {
				mg_log(LOG_ERR,
				    "invalid IPv4 address line %d",
				    conf_line);
				exit(EX_DATAERR);
			}
			peer_add(addr, (time_t)humanized_atoi((yyvsp[0].delay)));
		}
#line 2730 "y.tab.c"
    break;

  case 85: /* peeraddr: PEER IP6ADDR GLTIMEOUT TNUMBER  */
#line 342 "conf_yacc.y"
                                                {
#ifdef AF_INET6
			char addr[IPADDRSTRLEN];

			if (IP6TOSTRING((yyvsp[-2].ip6addr), addr) == NULL) {
				mg_log(LOG_ERR, 
				    "invalid IPv6 address line %d",
				    conf_line);
				exit(EX_DATAERR);
			}
			peer_add(addr, (time_t)humanized_atoi((yyvsp[0].delay)));
#else
			mg_log(LOG_INFO,
			    "IPv6 is not supported, ignore line %d",
			    conf_line);
#endif
		}
#line 2752 "y.tab.c"
    break;

  case 86: /* peeraddr: PEER DOMAINNAME GLTIMEOUT TNUMBER  */
#line 359 "conf_yacc.y"
                                                        {
#ifdef HAVE_GETADDRINFO
			peer_add((yyvsp[-2].domainname), (time_t)humanized_atoi((yyvsp[0].delay)));
#else
			mg_log(LOG_INFO,
			    "FQDN in peer is not supported, "
			    "ignore line %d", conf_line);
#endif
		}
#line 2766 "y.tab.c"
    break;

  case 87: /* peeraddr: PEER IPADDR  */
#line 368 "conf_yacc.y"
                                {
			char addr[IPADDRSTRLEN];

			if (IP4TOSTRING((yyvsp[0].ipaddr), addr) == NULL) {
				mg_log(LOG_ERR,
				    "invalid IPv4 address line %d",
				    conf_line);
				exit(EX_DATAERR);
			}
			peer_add(addr, (time_t)COM_TIMEOUT);
		}
#line 2782 "y.tab.c"
    break;

  case 88: /* peeraddr: PEER IP6ADDR  */
#line 379 "conf_yacc.y"
                                {
#ifdef AF_INET6
			char addr[IPADDRSTRLEN];

			if (IP6TOSTRING((yyvsp[0].ip6addr), addr) == NULL) {
				mg_log(LOG_ERR, 
				    "invalid IPv6 address line %d",
				    conf_line);
				exit(EX_DATAERR);
			}
			peer_add(addr, (time_t)COM_TIMEOUT);
#else
			mg_log(LOG_INFO,
			    "IPv6 is not supported, ignore line %d",
			    conf_line);
#endif
		}
#line 2804 "y.tab.c"
    break;

  case 89: /* peeraddr: PEER DOMAINNAME  */
#line 396 "conf_yacc.y"
                                {
#ifdef HAVE_GETADDRINFO
			peer_add((yyvsp[0].domainname), (time_t)COM_TIMEOUT);
#else
			mg_log(LOG_INFO,
			    "FQDN in peer is not supported, "
			    "ignore line %d", conf_line);
#endif
		}
#line 2818 "y.tab.c"
    break;

  case 90: /* autowhite: AUTOWHITE TDELAY  */
#line 406 "conf_yacc.y"
                                { if (C_NOTFORCED(C_AUTOWHITE))
					conf.c_autowhite_validity =
					    (time_t)humanized_atoi((yyvsp[0].delay));
				}
#line 2827 "y.tab.c"
    break;

  case 91: /* autowhite: AUTOWHITE TNUMBER  */
#line 410 "conf_yacc.y"
                                 { if (C_NOTFORCED(C_AUTOWHITE))
					conf.c_autowhite_validity =
					    (time_t)humanized_atoi((yyvsp[0].delay));
				}
#line 2836 "y.tab.c"
    break;

  case 92: /* greylist: GREYLIST TDELAY  */
#line 415 "conf_yacc.y"
                                { if (C_NOTFORCED(C_DELAY))
					conf.c_delay =
					    (time_t)humanized_atoi((yyvsp[0].delay));
				}
#line 2845 "y.tab.c"
    break;

  case 93: /* greylist: GREYLIST TNUMBER  */
#line 419 "conf_yacc.y"
                                { if (C_NOTFORCED(C_DELAY))
					conf.c_delay =
					    (time_t)humanized_atoi((yyvsp[0].delay));
				}
#line 2854 "y.tab.c"
    break;

  case 94: /* tarpit: TARPIT TDELAY  */
#line 424 "conf_yacc.y"
                                {
#ifdef HAVE_DATA_CALLBACK
			if (C_NOTFORCED(C_TARPIT))
				conf.c_tarpit = (time_t)humanized_atoi((yyvsp[0].delay));
#else
			mg_log(LOG_ERR, "libmilter >= 8.14 is required "
					"for tarpit, line %d",
					conf_line);
			exit(EX_DATAERR);
#endif
		}
#line 2870 "y.tab.c"
    break;

  case 95: /* tarpit: TARPIT TNUMBER  */
#line 435 "conf_yacc.y"
                                {
#ifdef HAVE_DATA_CALLBACK
			if (C_NOTFORCED(C_TARPIT))
				conf.c_tarpit = (time_t)humanized_atoi((yyvsp[0].delay));
#else
			mg_log(LOG_ERR, "libmilter >= 8.14 is required "
					"for tarpit, line %d",
					conf_line);
			exit(EX_DATAERR);
#endif
		}
#line 2886 "y.tab.c"
    break;

  case 96: /* tarpit_scope: TARPIT_SCOPE SESSION  */
#line 448 "conf_yacc.y"
                                     {
#ifdef HAVE_DATA_CALLBACK
			if (C_NOTFORCED(C_TARPIT_SCOPE))
				conf.c_tarpit_scope = TAP_SESSION;
#else
			mg_log(LOG_ERR, "libmilter >= 8.14 is required "
					"for tarpit_scope, line %d",
					conf_line);
			exit(EX_DATAERR);
#endif
		}
#line 2902 "y.tab.c"
    break;

  case 97: /* tarpit_scope: TARPIT_SCOPE COMMAND  */
#line 459 "conf_yacc.y"
                                     {
#ifdef HAVE_DATA_CALLBACK
			if (C_NOTFORCED(C_TARPIT_SCOPE))
				conf.c_tarpit_scope = TAP_COMMAND;
#else
			mg_log(LOG_ERR, "libmilter >= 8.14 is required "
					"for tarpit_scope, line %d",
					conf_line);
			exit(EX_DATAERR);
#endif
		}
#line 2918 "y.tab.c"
    break;

  case 98: /* verbose: VERBOSE  */
#line 471 "conf_yacc.y"
                        { if (C_NOTFORCED(C_DEBUG)) conf.c_debug = 1; }
#line 2924 "y.tab.c"
    break;

  case 99: /* dump_no_time_translation: DUMP_NO_TIME_TRANSLATION  */
#line 473 "conf_yacc.y"
                                                                { 
			conf.c_dump_no_time_translation = 1; 
			}
#line 2932 "y.tab.c"
    break;

  case 100: /* logexpired: LOGEXPIRED  */
#line 477 "conf_yacc.y"
                         { conf.c_logexpired = 1; }
#line 2938 "y.tab.c"
    break;

  case 101: /* quiet: QUIET  */
#line 479 "conf_yacc.y"
                        { if (C_NOTFORCED(C_QUIET)) conf.c_quiet = 1; }
#line 2944 "y.tab.c"
    break;

  case 102: /* noauth: NOAUTH  */
#line 481 "conf_yacc.y"
                        { if (C_NOTFORCED(C_NOAUTH)) conf.c_noauth = 1; }
#line 2950 "y.tab.c"
    break;

  case 103: /* multiracl: MULTIRACL  */
#line 483 "conf_yacc.y"
                          { conf.c_multiracl = 1; }
#line 2956 "y.tab.c"
    break;

  case 104: /* noaccessdb: NOACCESSDB  */
#line 485 "conf_yacc.y"
                                { conf.c_noaccessdb = 1; }
#line 2962 "y.tab.c"
    break;

  case 105: /* extendedregex: EXTENDEDREGEX  */
#line 487 "conf_yacc.y"
                                { conf.c_extendedregex = 1; }
#line 2968 "y.tab.c"
    break;

  case 106: /* unbracket: UNBRACKET  */
#line 489 "conf_yacc.y"
                                { conf.c_unbracket = 1; }
#line 2974 "y.tab.c"
    break;

  case 107: /* nospf: NOSPF  */
#line 491 "conf_yacc.y"
                        { if (C_NOTFORCED(C_NOSPF)) conf.c_nospf = 1; }
#line 2980 "y.tab.c"
    break;

  case 108: /* delayedreject: DELAYEDREJECT  */
#line 493 "conf_yacc.y"
                                { conf.c_delayedreject = 1; }
#line 2986 "y.tab.c"
    break;

  case 109: /* testmode: TESTMODE  */
#line 495 "conf_yacc.y"
                        { if (C_NOTFORCED(C_TESTMODE)) conf.c_testmode = 1; }
#line 2992 "y.tab.c"
    break;

  case 110: /* nodetach: NODETACH  */
#line 497 "conf_yacc.y"
                        { if (C_NOTFORCED(C_NODETACH)) conf.c_nodetach = 1; }
#line 2998 "y.tab.c"
    break;

  case 111: /* lazyaw: LAZYAW  */
#line 499 "conf_yacc.y"
                        { if (C_NOTFORCED(C_LAZYAW)) conf.c_lazyaw = 1; }
#line 3004 "y.tab.c"
    break;

  case 112: /* domainexact: DOMAINEXACT  */
#line 501 "conf_yacc.y"
                                { if (C_NOTFORCED(C_DOMAINEXACT)) 
					conf.c_domainexact = 1;
				}
#line 3012 "y.tab.c"
    break;

  case 113: /* pidfile: PIDFILE QSTRING  */
#line 505 "conf_yacc.y"
                                { if (C_NOTFORCED(C_PIDFILE)) 
					conf.c_pidfile = 
					    quotepath(conf.c_pidfile_storage, 
						(yyvsp[0].qstring), QSTRLEN);
				}
#line 3022 "y.tab.c"
    break;

  case 114: /* dumpfile: GLDUMPFILE QSTRING  */
#line 511 "conf_yacc.y"
                                  { if (C_NOTFORCED(C_DUMPFILE)) 
					conf.c_dumpfile = 
					    quotepath(conf.c_dumpfile_storage, 
					    (yyvsp[0].qstring), QSTRLEN);
				}
#line 3032 "y.tab.c"
    break;

  case 115: /* dumpfile: GLDUMPFILE QSTRING TNUMBER  */
#line 516 "conf_yacc.y"
                                                {
				if (C_NOTFORCED(C_DUMPFILE))
					conf.c_dumpfile = 
					    quotepath(conf.c_dumpfile_storage, 
					    (yyvsp[-1].qstring), QSTRLEN);

				conf.c_dumpfile_mode = (int)strtol((yyvsp[0].delay), NULL, 8);
			}
#line 3045 "y.tab.c"
    break;

  case 116: /* subnetmatch: SUBNETMATCH CIDR  */
#line 525 "conf_yacc.y"
                                { if (C_NOTFORCED(C_MATCHMASK))
					prefix2mask4((yyvsp[0].cidr), &conf.c_match_mask);
				}
#line 3053 "y.tab.c"
    break;

  case 117: /* subnetmatch6: SUBNETMATCH6 CIDR  */
#line 529 "conf_yacc.y"
                                 { 
#ifdef AF_INET6
				if (C_NOTFORCED(C_MATCHMASK6))
					prefix2mask6((yyvsp[0].cidr), &conf.c_match_mask6);
#else
				mg_log(LOG_INFO, "IPv6 is not supported, "
				    "ignore line %d", conf_line);
#endif
				}
#line 3067 "y.tab.c"
    break;

  case 118: /* socket: SOCKET QSTRING  */
#line 539 "conf_yacc.y"
                                { if (C_NOTFORCED(C_SOCKET))
					conf.c_socket = 
					    quotepath(conf.c_socket_storage, 
					    (yyvsp[0].qstring), QSTRLEN);
				}
#line 3077 "y.tab.c"
    break;

  case 119: /* socket: SOCKET QSTRING TNUMBER  */
#line 544 "conf_yacc.y"
                                        {
				int mode = atoi((yyvsp[0].delay));

				if (C_NOTFORCED(C_SOCKET))
					conf.c_socket = 
					    quotepath(conf.c_socket_storage, 
					    (yyvsp[-1].qstring), QSTRLEN);

				switch(mode) {
				case 666:
					conf.c_socket_mode = 0666;
					break;
				case 660:
					conf.c_socket_mode = 0660;
					break;
				case 600:
					conf.c_socket_mode = 0600;
					break;
				default:
					mg_log(LOG_ERR, "socket mode %d is "
					    "not allowed, Use either 666, "
					    "660, or 600", mode);
					exit(EX_DATAERR);
				}
			}
#line 3107 "y.tab.c"
    break;

  case 120: /* user: USER QSTRING  */
#line 570 "conf_yacc.y"
                                { if (C_NOTFORCED(C_USER))
					conf.c_user =
					    quotepath(conf.c_user_storage, (yyvsp[0].qstring), QSTRLEN);
				}
#line 3116 "y.tab.c"
    break;

  case 121: /* p0fsockdef: P0FSOCK QSTRING  */
#line 575 "conf_yacc.y"
                                {
#ifdef USE_P0F
				char path[QSTRLEN + 1];

				p0f_sock_set(quotepath(path, (yyvsp[0].qstring), QSTRLEN));
#else
				mg_log(LOG_INFO, 
				    "p0f support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
				}
#line 3133 "y.tab.c"
    break;

  case 122: /* spamdsockdef: SPAMDSOCK SPAMDSOCKT QSTRING  */
#line 588 "conf_yacc.y"
                                                {
#ifdef USE_SPAMD
				char path[QSTRLEN + 1];

				spamd_sock_set((yyvsp[-1].spamdsockt), 
					       quotepath(path, (yyvsp[0].qstring), QSTRLEN));
#else
				mg_log(LOG_INFO, 
				    "spamassassin support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
				}
#line 3151 "y.tab.c"
    break;

  case 123: /* tsigdef: TSIG QSTRING QSTRING QSTRING  */
#line 602 "conf_yacc.y"
                                                        {
#ifdef USE_NSUPDATE
				char name[QSTRLEN + 1];
				char alg[QSTRLEN + 1];
				char key[QSTRLEN + 1];

				if (tsig_add(quotepath(name, (yyvsp[-2].qstring), QSTRLEN),
					     quotepath(alg, (yyvsp[-1].qstring), QSTRLEN),
					     quotepath(key, (yyvsp[0].qstring), QSTRLEN))) {
					mg_log(LOG_ERR, "error at %d",
					       conf_line);
					exit(EX_DATAERR);
				}
#else
				mg_log(LOG_INFO, 
				    "nsupdate support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
			}
#line 3176 "y.tab.c"
    break;

  case 124: /* nsupdatedef: NSUPDATE QSTRING OPENLIST nsupdatedefitems CLOSELIST  */
#line 623 "conf_yacc.y"
                                                                             {
#ifdef USE_NSUPDATE
				char name[QSTRLEN + 1];

				if (nsupdate_add(quotepath(name, (yyvsp[-3].qstring), QSTRLEN))){
					mg_log(LOG_ERR, "error at %d",
					       conf_line);
					exit(EX_DATAERR);
				}
#else
				mg_log(LOG_INFO, 
				    "nsupdate support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
			}
#line 3197 "y.tab.c"
    break;

  case 133: /* nsupdatedefservers: SERVERS QSTRING  */
#line 650 "conf_yacc.y"
                                        {
#ifdef USE_NSUPDATE
				char name[QSTRLEN + 1];

				if (nsupdate_add_servers(quotepath(name,
				    (yyvsp[0].qstring), QSTRLEN))) {
					mg_log(LOG_ERR, "error at %d",
					       conf_line);
					exit(EX_DATAERR);
				}
#else
				mg_log(LOG_INFO, 
				    "nsupdate support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
			}
#line 3219 "y.tab.c"
    break;

  case 134: /* nsupdatedefrname: RNAME QSTRING  */
#line 668 "conf_yacc.y"
                                      {
#ifdef USE_NSUPDATE
				char name[QSTRLEN + 1];

				if (nsupdate_add_rname(quotepath(name,
				    (yyvsp[0].qstring), QSTRLEN))) {
					mg_log(LOG_ERR, "error at %d",
					       conf_line);
					exit(EX_DATAERR);
				}
#else
				mg_log(LOG_INFO, 
				    "nsupdate support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
			}
#line 3241 "y.tab.c"
    break;

  case 135: /* nsupdatedefrvalue: RVALUE QSTRING  */
#line 686 "conf_yacc.y"
                                       {
#ifdef USE_NSUPDATE
				char name[QSTRLEN + 1];

				if (nsupdate_add_rvalue(quotepath(name,
				    (yyvsp[0].qstring), QSTRLEN))) {
					mg_log(LOG_ERR, "error at %d",
					       conf_line);
					exit(EX_DATAERR);
				}
#else
				mg_log(LOG_INFO, 
				    "nsupdate support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
			}
#line 3263 "y.tab.c"
    break;

  case 136: /* nsupdatedefttl: TTL TDELAY  */
#line 704 "conf_yacc.y"
                                   {
#ifdef USE_NSUPDATE
				if (nsupdate_add_ttl(humanized_atoi((yyvsp[0].delay)))) {
					mg_log(LOG_ERR, "error at %d",
					       conf_line);
					exit(EX_DATAERR);
				}
#else
				mg_log(LOG_INFO, 
				    "nsupdate support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
			}
#line 3282 "y.tab.c"
    break;

  case 137: /* nsupdatedefclass: CLASS TNUMBER  */
#line 719 "conf_yacc.y"
                                      {
#ifdef USE_NSUPDATE
				if (nsupdate_add_class(atoi((yyvsp[0].delay)))) {
					mg_log(LOG_ERR, "error at %d",
					       conf_line);
					exit(EX_DATAERR);
				}
#else
				mg_log(LOG_INFO, 
				    "nsupdate support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
			}
#line 3301 "y.tab.c"
    break;

  case 138: /* nsupdatedeftype: TYPE TNUMBER  */
#line 734 "conf_yacc.y"
                                     {
#ifdef USE_NSUPDATE
				if (nsupdate_add_type(atoi((yyvsp[0].delay)))) {
					mg_log(LOG_ERR, "error at %d",
					       conf_line);
					exit(EX_DATAERR);
				}
#else
				mg_log(LOG_INFO, 
				    "nsupdate support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
			}
#line 3320 "y.tab.c"
    break;

  case 139: /* nsupdatedeftsig: TSIG QSTRING  */
#line 749 "conf_yacc.y"
                                     {
#ifdef USE_NSUPDATE
				char name[QSTRLEN + 1];

				if (nsupdate_add_tsig(quotepath(name,
				    (yyvsp[0].qstring), QSTRLEN))) {
					mg_log(LOG_ERR, "error at %d",
					       conf_line);
					exit(EX_DATAERR);
				}
#else
				mg_log(LOG_INFO, 
				    "nsupdate support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
			}
#line 3342 "y.tab.c"
    break;

  case 140: /* geoipdb: GEOIPDB QSTRING  */
#line 767 "conf_yacc.y"
                                {
#ifdef USE_GEOIP
				char path[QSTRLEN + 1];

				geoip_set_db(quotepath(path, (yyvsp[0].qstring), QSTRLEN));
#else
				mg_log(LOG_INFO, 
				    "GeoIP support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
				}
#line 3359 "y.tab.c"
    break;

  case 141: /* geoipv6db: GEOIPV6DB QSTRING  */
#line 780 "conf_yacc.y"
                                        {
#ifdef USE_GEOIP
				char path[QSTRLEN + 1];

				geoip_set_db_v6(quotepath(path, (yyvsp[0].qstring), QSTRLEN));
#else
				mg_log(LOG_INFO, 
				    "GeoIP support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
				}
#line 3376 "y.tab.c"
    break;

  case 142: /* geoip2db: GEOIP2DB QSTRING  */
#line 793 "conf_yacc.y"
                                        {
#ifdef USE_GEOIP2
				char path[QSTRLEN + 1];

				geoip2_set_db(quotepath(path, (yyvsp[0].qstring), QSTRLEN));
#else
				mg_log(LOG_INFO,
				    "GeoIP2 support not compiled in, "
				    "ignore line %d",
				    conf_line);
#endif
				}
#line 3393 "y.tab.c"
    break;

  case 143: /* report: REPORT NONE  */
#line 806 "conf_yacc.y"
                                { conf.c_report = C_GLNONE; }
#line 3399 "y.tab.c"
    break;

  case 144: /* report: REPORT DELAYS  */
#line 807 "conf_yacc.y"
                                { conf.c_report = C_DELAYS; }
#line 3405 "y.tab.c"
    break;

  case 145: /* report: REPORT NODELAYS  */
#line 808 "conf_yacc.y"
                                { conf.c_report = C_NODELAYS; }
#line 3411 "y.tab.c"
    break;

  case 146: /* report: REPORT ALL  */
#line 809 "conf_yacc.y"
                                { conf.c_report = C_ALL; }
#line 3417 "y.tab.c"
    break;

  case 147: /* logfac: LOGFAC NONE  */
#line 812 "conf_yacc.y"
                    { conf.c_logfac = -1; }
#line 3423 "y.tab.c"
    break;

  case 148: /* logfac: LOGFAC LOGFAC_KERN  */
#line 813 "conf_yacc.y"
                                   { conf.c_logfac = LOG_KERN; }
#line 3429 "y.tab.c"
    break;

  case 149: /* logfac: LOGFAC LOGFAC_USER  */
#line 814 "conf_yacc.y"
                                   { conf.c_logfac = LOG_USER; }
#line 3435 "y.tab.c"
    break;

  case 150: /* logfac: LOGFAC LOGFAC_MAIL  */
#line 815 "conf_yacc.y"
                                   { conf.c_logfac = LOG_MAIL; }
#line 3441 "y.tab.c"
    break;

  case 151: /* logfac: LOGFAC LOGFAC_DAEMON  */
#line 816 "conf_yacc.y"
                                     { conf.c_logfac = LOG_DAEMON; }
#line 3447 "y.tab.c"
    break;

  case 152: /* logfac: LOGFAC LOGFAC_AUTH  */
#line 817 "conf_yacc.y"
                                   { conf.c_logfac = LOG_AUTH; }
#line 3453 "y.tab.c"
    break;

  case 153: /* logfac: LOGFAC LOGFAC_SYSLOG  */
#line 818 "conf_yacc.y"
                                     { conf.c_logfac = LOG_SYSLOG; }
#line 3459 "y.tab.c"
    break;

  case 154: /* logfac: LOGFAC LOGFAC_LPR  */
#line 819 "conf_yacc.y"
                                  { conf.c_logfac = LOG_LPR; }
#line 3465 "y.tab.c"
    break;

  case 155: /* logfac: LOGFAC LOGFAC_NEWS  */
#line 820 "conf_yacc.y"
                                   { conf.c_logfac = LOG_NEWS; }
#line 3471 "y.tab.c"
    break;

  case 156: /* logfac: LOGFAC LOGFAC_UUCP  */
#line 821 "conf_yacc.y"
                                   { conf.c_logfac = LOG_UUCP; }
#line 3477 "y.tab.c"
    break;

  case 157: /* logfac: LOGFAC LOGFAC_CRON  */
#line 822 "conf_yacc.y"
                                   { conf.c_logfac = LOG_CRON; }
#line 3483 "y.tab.c"
    break;

  case 158: /* logfac: LOGFAC LOGFAC_AUTHPRIV  */
#line 823 "conf_yacc.y"
                                       {
#ifdef LOG_AUTHPRIV
		      conf.c_logfac = LOG_AUTHPRIV;
#else
		      mg_log(LOG_ERR, "Your system does not support "
		      		      "authpriv syslog facility, line %d",
		      		      conf_line);
		      exit(EX_DATAERR);
#endif
		}
#line 3498 "y.tab.c"
    break;

  case 159: /* logfac: LOGFAC LOGFAC_FTP  */
#line 833 "conf_yacc.y"
                                  {
#ifdef LOG_FTP
		      conf.c_logfac = LOG_FTP;
#else
		      mg_log(LOG_ERR, "Your system does not support "
		      		      "ftp syslog facility, line %d",
		      		      conf_line);
		      exit(EX_DATAERR);
#endif
		}
#line 3513 "y.tab.c"
    break;

  case 160: /* logfac: LOGFAC LOGFAC_LOCAL0  */
#line 843 "conf_yacc.y"
                                     { conf.c_logfac = LOG_LOCAL0; }
#line 3519 "y.tab.c"
    break;

  case 161: /* logfac: LOGFAC LOGFAC_LOCAL1  */
#line 844 "conf_yacc.y"
                                     { conf.c_logfac = LOG_LOCAL1; }
#line 3525 "y.tab.c"
    break;

  case 162: /* logfac: LOGFAC LOGFAC_LOCAL2  */
#line 845 "conf_yacc.y"
                                     { conf.c_logfac = LOG_LOCAL2; }
#line 3531 "y.tab.c"
    break;

  case 163: /* logfac: LOGFAC LOGFAC_LOCAL3  */
#line 846 "conf_yacc.y"
                                     { conf.c_logfac = LOG_LOCAL3; }
#line 3537 "y.tab.c"
    break;

  case 164: /* logfac: LOGFAC LOGFAC_LOCAL4  */
#line 847 "conf_yacc.y"
                                     { conf.c_logfac = LOG_LOCAL4; }
#line 3543 "y.tab.c"
    break;

  case 165: /* logfac: LOGFAC LOGFAC_LOCAL5  */
#line 848 "conf_yacc.y"
                                     { conf.c_logfac = LOG_LOCAL5; }
#line 3549 "y.tab.c"
    break;

  case 166: /* logfac: LOGFAC LOGFAC_LOCAL6  */
#line 849 "conf_yacc.y"
                                     { conf.c_logfac = LOG_LOCAL6; }
#line 3555 "y.tab.c"
    break;

  case 167: /* logfac: LOGFAC LOGFAC_LOCAL7  */
#line 850 "conf_yacc.y"
                                     { conf.c_logfac = LOG_LOCAL7; }
#line 3561 "y.tab.c"
    break;

  case 168: /* statdef: STAT QSTRING QSTRING  */
#line 853 "conf_yacc.y"
                                        { 
				char output[QSTRLEN + 1];
				char format[QSTRLEN + 1];

				mg_stat_def(quotepath(output, (yyvsp[-1].qstring), QSTRLEN),
					    quotepath(format, (yyvsp[0].qstring), QSTRLEN));
		}
#line 3573 "y.tab.c"
    break;

  case 169: /* dumpfreq: GLDUMPFREQ TDELAY  */
#line 862 "conf_yacc.y"
                                  { conf.c_dumpfreq =
				    (time_t)humanized_atoi((yyvsp[0].delay));
				}
#line 3581 "y.tab.c"
    break;

  case 170: /* dumpfreq: GLDUMPFREQ TNUMBER  */
#line 865 "conf_yacc.y"
                                   { conf.c_dumpfreq =
				    (time_t)humanized_atoi((yyvsp[0].delay));
				}
#line 3589 "y.tab.c"
    break;

  case 171: /* timeout: GLTIMEOUT TDELAY  */
#line 869 "conf_yacc.y"
                                 { conf.c_timeout =
				    (time_t)humanized_atoi((yyvsp[0].delay));
				}
#line 3597 "y.tab.c"
    break;

  case 172: /* timeout: GLTIMEOUT TNUMBER  */
#line 872 "conf_yacc.y"
                                  { conf.c_timeout =
				    (time_t)humanized_atoi((yyvsp[0].delay));
				}
#line 3605 "y.tab.c"
    break;

  case 173: /* syncaddr: SYNCADDR STAR  */
#line 876 "conf_yacc.y"
                                {
				   conf.c_syncaddr = NULL;
				   conf.c_syncport = NULL;
				}
#line 3614 "y.tab.c"
    break;

  case 174: /* syncaddr: SYNCADDR IPADDR  */
#line 880 "conf_yacc.y"
                                {
				if (IP4TOSTRING((yyvsp[0].ipaddr), conf.c_syncaddr_storage) == NULL) {
					mg_log(LOG_ERR, "invalid IPv4 address "
					    "line %d", conf_line);
					exit(EX_DATAERR);
				}
				conf.c_syncaddr = conf.c_syncaddr_storage;
				conf.c_syncport = NULL;
	                        }
#line 3628 "y.tab.c"
    break;

  case 175: /* syncaddr: SYNCADDR IP6ADDR  */
#line 889 "conf_yacc.y"
                                 {
#ifdef AF_INET6
				if (IP6TOSTRING((yyvsp[0].ip6addr), conf.c_syncaddr_storage) == NULL) {
					mg_log(LOG_ERR, "invalid IPv6 address "
					    "line %d", conf_line);
					exit(EX_DATAERR);
				}
				conf.c_syncaddr = conf.c_syncaddr_storage;
				conf.c_syncport = NULL;
#else /* AF_INET6 */
				mg_log(LOG_INFO, "IPv6 is not supported, "
				    "ignore line %d", conf_line);
#endif /* AF_INET6 */
				}
#line 3647 "y.tab.c"
    break;

  case 176: /* syncaddr: SYNCADDR STAR PORT TNUMBER  */
#line 903 "conf_yacc.y"
                                           {
				conf.c_syncaddr = NULL;
				conf.c_syncport = conf.c_syncport_storage;
				strncpy(conf.c_syncport, (yyvsp[0].delay), NUMLEN);
				conf.c_syncport[NUMLEN] = '\0';
				}
#line 3658 "y.tab.c"
    break;

  case 177: /* syncaddr: SYNCADDR IPADDR PORT TNUMBER  */
#line 909 "conf_yacc.y"
                                             {
				if (IP4TOSTRING((yyvsp[-2].ipaddr), conf.c_syncaddr_storage) == NULL) {
					mg_log(LOG_ERR, "invalid IPv4 address "
					    "line %d", conf_line);
					exit(EX_DATAERR);
				}
				conf.c_syncaddr = conf.c_syncaddr_storage;
				conf.c_syncport = conf.c_syncport_storage;
				strncpy(conf.c_syncport, (yyvsp[0].delay), NUMLEN);
				conf.c_syncport[NUMLEN] = '\0';
				}
#line 3674 "y.tab.c"
    break;

  case 178: /* syncaddr: SYNCADDR IP6ADDR PORT TNUMBER  */
#line 920 "conf_yacc.y"
                                              {
#ifdef AF_INET6
				if (IP6TOSTRING((yyvsp[-2].ip6addr), conf.c_syncaddr_storage) == NULL) {
					mg_log(LOG_ERR, "invalid IPv6 address "
					    "line %d", conf_line);
					exit(EX_DATAERR);
				}
				conf.c_syncaddr = conf.c_syncaddr_storage;
				conf.c_syncport = conf.c_syncport_storage;
				strncpy(conf.c_syncport, (yyvsp[0].delay), NUMLEN);
				conf.c_syncport[NUMLEN] = '\0';
#else /* AF_INET6 */
				mg_log(LOG_INFO, "IPv6 is not supported, "
				    "ignore line %d", conf_line);
#endif /* AF_INET6 */
				}
#line 3695 "y.tab.c"
    break;

  case 179: /* syncsrcaddr: SYNCSRCADDR STAR  */
#line 938 "conf_yacc.y"
                                        {
				   conf.c_syncsrcaddr = NULL;
				   conf.c_syncsrcport = NULL;
				}
#line 3704 "y.tab.c"
    break;

  case 180: /* syncsrcaddr: SYNCSRCADDR IPADDR  */
#line 942 "conf_yacc.y"
                                        {
				if (IP4TOSTRING((yyvsp[0].ipaddr), conf.c_syncsrcaddr_storage) == NULL) {
					mg_log(LOG_ERR, "invalid IPv4 address "
					    "line %d", conf_line);
					exit(EX_DATAERR);
				}
				conf.c_syncsrcaddr = conf.c_syncsrcaddr_storage;
				conf.c_syncsrcport = NULL;
	                        }
#line 3718 "y.tab.c"
    break;

  case 181: /* syncsrcaddr: SYNCSRCADDR IP6ADDR  */
#line 951 "conf_yacc.y"
                                    {
#ifdef AF_INET6
				if (IP6TOSTRING((yyvsp[0].ip6addr), conf.c_syncsrcaddr_storage) == NULL) {
					mg_log(LOG_ERR, "invalid IPv6 address "
					    "line %d", conf_line);
					exit(EX_DATAERR);
				}
				conf.c_syncsrcaddr = conf.c_syncsrcaddr_storage;
				conf.c_syncsrcport = NULL;
#else /* AF_INET6 */
				mg_log(LOG_INFO, "IPv6 is not supported, "
				    "ignore line %d", conf_line);
#endif /* AF_INET6 */
				}
#line 3737 "y.tab.c"
    break;

  case 182: /* syncsrcaddr: SYNCSRCADDR STAR PORT TNUMBER  */
#line 965 "conf_yacc.y"
                                              {
				conf.c_syncsrcaddr = NULL;
				conf.c_syncsrcport = conf.c_syncsrcport_storage;
				strncpy(conf.c_syncsrcport, (yyvsp[0].delay), NUMLEN);
				conf.c_syncsrcport[NUMLEN] = '\0';
				}
#line 3748 "y.tab.c"
    break;

  case 183: /* syncsrcaddr: SYNCSRCADDR IPADDR PORT TNUMBER  */
#line 971 "conf_yacc.y"
                                                {
				if (IP4TOSTRING((yyvsp[-2].ipaddr), conf.c_syncsrcaddr_storage) == NULL) {
					mg_log(LOG_ERR, "invalid IPv4 address "
					    "line %d", conf_line);
					exit(EX_DATAERR);
				}
				conf.c_syncsrcaddr = conf.c_syncsrcaddr_storage;
				conf.c_syncsrcport = conf.c_syncsrcport_storage;
				strncpy(conf.c_syncsrcport, (yyvsp[0].delay), NUMLEN);
				conf.c_syncsrcport[NUMLEN] = '\0';
				}
#line 3764 "y.tab.c"
    break;

  case 184: /* syncsrcaddr: SYNCSRCADDR IP6ADDR PORT TNUMBER  */
#line 982 "conf_yacc.y"
                                                 {
#ifdef AF_INET6
				if (IP6TOSTRING((yyvsp[-2].ip6addr), conf.c_syncsrcaddr_storage) == NULL) {
					mg_log(LOG_ERR, "invalid IPv6 address "
					    "line %d", conf_line);
					exit(EX_DATAERR);
				}
				conf.c_syncsrcaddr = conf.c_syncsrcaddr_storage;
				conf.c_syncsrcport = conf.c_syncsrcport_storage;
				strncpy(conf.c_syncsrcport, (yyvsp[0].delay), NUMLEN);
				conf.c_syncsrcport[NUMLEN] = '\0';
#else /* AF_INET6 */
				mg_log(LOG_INFO, "IPv6 is not supported, "
				    "ignore line %d", conf_line);
#endif /* AF_INET6 */
				}
#line 3785 "y.tab.c"
    break;

  case 185: /* syncmaxqlen: SYNCMAXQLEN TNUMBER  */
#line 1000 "conf_yacc.y"
                                    { conf.c_syncmaxqlen = atoi((yyvsp[0].delay)) ; 
		}
#line 3792 "y.tab.c"
    break;

  case 186: /* ratelimitdef: RATELIMIT QSTRING RCPT TNUMBER SLASH TDELAY  */
#line 1004 "conf_yacc.y"
                                                            {
			char name[QSTRLEN + 1];

			ratelimit_conf_add(quotepath(name, (yyvsp[-4].qstring), QSTRLEN), 
					   RL_RCPT, humanized_atoi((yyvsp[-2].delay)),
					   humanized_atoi((yyvsp[0].delay)), NULL);
		}
#line 3804 "y.tab.c"
    break;

  case 187: /* ratelimitdef: RATELIMIT QSTRING RCPT TNUMBER SLASH TDELAY KEY QSTRING  */
#line 1011 "conf_yacc.y"
                                                                        {
			char name[QSTRLEN + 1];
			char key[QSTRLEN + 1];
			ratelimit_conf_add(quotepath(name, (yyvsp[-6].qstring), QSTRLEN), 
					   RL_RCPT, humanized_atoi((yyvsp[-4].delay)),
					   humanized_atoi((yyvsp[-2].delay)), 
					   quotepath(key, (yyvsp[0].qstring), QSTRLEN));
		}
#line 3817 "y.tab.c"
    break;

  case 188: /* ratelimitdef: RATELIMIT QSTRING SESSION TNUMBER SLASH TDELAY  */
#line 1019 "conf_yacc.y"
                                                               {
			char name[QSTRLEN + 1];

			ratelimit_conf_add(quotepath(name, (yyvsp[-4].qstring), QSTRLEN), 
					   RL_SESS, humanized_atoi((yyvsp[-2].delay)),
					   humanized_atoi((yyvsp[0].delay)), NULL);
		}
#line 3829 "y.tab.c"
    break;

  case 189: /* ratelimitdef: RATELIMIT QSTRING SESSION TNUMBER SLASH TDELAY KEY QSTRING  */
#line 1026 "conf_yacc.y"
                                                                           {
			char name[QSTRLEN + 1];
			char key[QSTRLEN + 1];
			ratelimit_conf_add(quotepath(name, (yyvsp[-6].qstring), QSTRLEN), 
					   RL_SESS, humanized_atoi((yyvsp[-4].delay)),
					   humanized_atoi((yyvsp[-2].delay)), 
					   quotepath(key, (yyvsp[0].qstring), QSTRLEN));
		}
#line 3842 "y.tab.c"
    break;

  case 190: /* ratelimitdef: RATELIMIT QSTRING DATA TNUMBER SLASH TDELAY  */
#line 1034 "conf_yacc.y"
                                                            {
			char name[QSTRLEN + 1];

			ratelimit_conf_add(quotepath(name, (yyvsp[-4].qstring), QSTRLEN), 
					   RL_DATA, humanized_atoi((yyvsp[-2].delay)),
					   humanized_atoi((yyvsp[0].delay)), NULL);
		}
#line 3854 "y.tab.c"
    break;

  case 191: /* ratelimitdef: RATELIMIT QSTRING DATA TNUMBER SLASH TDELAY KEY QSTRING  */
#line 1041 "conf_yacc.y"
                                                                        {
			char name[QSTRLEN + 1];
			char key[QSTRLEN + 1];
			ratelimit_conf_add(quotepath(name, (yyvsp[-6].qstring), QSTRLEN), 
					   RL_DATA, humanized_atoi((yyvsp[-4].delay)),
					   humanized_atoi((yyvsp[-2].delay)), 
					   quotepath(key, (yyvsp[0].qstring), QSTRLEN));
		}
#line 3867 "y.tab.c"
    break;

  case 192: /* access_list: ACL GREYLIST acl_entry  */
#line 1051 "conf_yacc.y"
                                        { 
			acl_register_entry_last(AS_RCPT, A_GREYLIST);
		}
#line 3875 "y.tab.c"
    break;

  case 193: /* access_list: ACL WHITELIST acl_entry  */
#line 1054 "conf_yacc.y"
                                        { 
			acl_register_entry_last(AS_RCPT, A_WHITELIST);
		}
#line 3883 "y.tab.c"
    break;

  case 194: /* access_list: ACL BLACKLIST acl_entry  */
#line 1057 "conf_yacc.y"
                                        { 
			acl_register_entry_last(AS_RCPT, A_BLACKLIST);
		}
#line 3891 "y.tab.c"
    break;

  case 195: /* rcpt_access_list: RACL id GREYLIST acl_entry  */
#line 1063 "conf_yacc.y"
                                            { 
			acl_register_entry_last(AS_RCPT, A_GREYLIST);
		}
#line 3899 "y.tab.c"
    break;

  case 196: /* rcpt_access_list: RACL id WHITELIST acl_entry  */
#line 1066 "conf_yacc.y"
                                            { 
			acl_register_entry_last(AS_RCPT, A_WHITELIST);
		}
#line 3907 "y.tab.c"
    break;

  case 197: /* rcpt_access_list: RACL id BLACKLIST acl_entry  */
#line 1069 "conf_yacc.y"
                                            { 
			acl_register_entry_last(AS_RCPT, A_BLACKLIST);
		}
#line 3915 "y.tab.c"
    break;

  case 198: /* rcpt_access_list: RACL id CONTINUE acl_entry  */
#line 1072 "conf_yacc.y"
                                           { 
			acl_register_entry_last(AS_RCPT, A_CONTINUE);
		}
#line 3923 "y.tab.c"
    break;

  case 199: /* data_access_list: DACL id GREYLIST acl_entry  */
#line 1078 "conf_yacc.y"
                                            { 
			acl_register_entry_last(AS_DATA, A_GREYLIST);
		}
#line 3931 "y.tab.c"
    break;

  case 200: /* data_access_list: DACL id WHITELIST acl_entry  */
#line 1081 "conf_yacc.y"
                                            { 
			acl_register_entry_last(AS_DATA, A_WHITELIST);
		}
#line 3939 "y.tab.c"
    break;

  case 201: /* data_access_list: DACL id BLACKLIST acl_entry  */
#line 1084 "conf_yacc.y"
                                            { 
			acl_register_entry_last(AS_DATA, A_BLACKLIST);
		}
#line 3947 "y.tab.c"
    break;

  case 202: /* data_access_list: DACL id CONTINUE acl_entry  */
#line 1087 "conf_yacc.y"
                                           { 
			acl_register_entry_last(AS_DATA, A_CONTINUE);
		}
#line 3955 "y.tab.c"
    break;

  case 203: /* id: QSTRING  */
#line 1092 "conf_yacc.y"
                        { 
			char id[QSTRLEN + 1];

			acl_add_id(quotepath(id, (yyvsp[0].qstring), QSTRLEN)); 
		}
#line 3965 "y.tab.c"
    break;

  case 205: /* acl_entry: acl_default_entry  */
#line 1100 "conf_yacc.y"
                                        { conf_acl_end = 1; }
#line 3971 "y.tab.c"
    break;

  case 297: /* greylist_value: GLXDELAY TDELAY  */
#line 1202 "conf_yacc.y"
                            { acl_add_delay((time_t)humanized_atoi((yyvsp[0].delay))); }
#line 3977 "y.tab.c"
    break;

  case 298: /* autowhite_value: AUTOWHITE TDELAY  */
#line 1205 "conf_yacc.y"
                            { acl_add_autowhite((time_t)humanized_atoi((yyvsp[0].delay))); }
#line 3983 "y.tab.c"
    break;

  case 299: /* tarpit_scope_value: TARPIT_SCOPE SESSION  */
#line 1209 "conf_yacc.y"
                            {
#ifdef HAVE_DATA_CALLBACK
				acl_add_tarpit_scope(TAP_SESSION);
#else
				mg_log(LOG_ERR, "libmilter >= 8.14 is required "
						"for tarpit_scope, line %d",
						conf_line);
				exit(EX_DATAERR);
#endif
			    }
#line 3998 "y.tab.c"
    break;

  case 300: /* tarpit_scope_value: TARPIT_SCOPE COMMAND  */
#line 1220 "conf_yacc.y"
                            {
#ifdef HAVE_DATA_CALLBACK
				acl_add_tarpit_scope(TAP_COMMAND);
#else
				mg_log(LOG_ERR, "libmilter >= 8.14 is required "
						"for tarpit_scope, line %d",
						conf_line);
				exit(EX_DATAERR);
#endif
			    }
#line 4013 "y.tab.c"
    break;

  case 301: /* flush_value: FLUSHADDR  */
#line 1231 "conf_yacc.y"
                                  { acl_add_flushaddr(); }
#line 4019 "y.tab.c"
    break;

  case 302: /* nolog_value: NOLOG  */
#line 1233 "conf_yacc.y"
                              { acl_add_nolog(); }
#line 4025 "y.tab.c"
    break;

  case 303: /* code_value: CODE QSTRING  */
#line 1235 "conf_yacc.y"
                                     {
				char code[QSTRLEN + 1];

				acl_add_code(quotepath(code, (yyvsp[0].qstring), QSTRLEN));
			}
#line 4035 "y.tab.c"
    break;

  case 304: /* ecode_value: ECODE QSTRING  */
#line 1241 "conf_yacc.y"
                                      {
				char ecode[QSTRLEN + 1];

				acl_add_ecode(quotepath(ecode, (yyvsp[0].qstring), QSTRLEN));
			}
#line 4045 "y.tab.c"
    break;

  case 305: /* msg_value: MSG QSTRING  */
#line 1247 "conf_yacc.y"
                                    {
				char msg[QSTRLEN + 1];

				acl_add_msg(quotepath(msg, (yyvsp[0].qstring), QSTRLEN));
			}
#line 4055 "y.tab.c"
    break;

  case 306: /* report_value: REPORT QSTRING  */
#line 1253 "conf_yacc.y"
                                       {
				char msg[QSTRLEN + 1];

				acl_add_report(quotepath(msg, (yyvsp[0].qstring), QSTRLEN));
			}
#line 4065 "y.tab.c"
    break;

  case 307: /* addheader_value: ADDHEADER QSTRING  */
#line 1259 "conf_yacc.y"
                                          {
				char hdr[QSTRLEN + 1];

				acl_add_addheader(
					quotepath(hdr, (yyvsp[0].qstring), QSTRLEN), -1);
			}
#line 4076 "y.tab.c"
    break;

  case 308: /* addheader_value: ADDHEADER QSTRING COMMA TNUMBER  */
#line 1265 "conf_yacc.y"
                                                {
				char hdr[QSTRLEN + 1];

				acl_add_addheader(
					quotepath(hdr, (yyvsp[-2].qstring), QSTRLEN), atoi((yyvsp[0].delay)));
			}
#line 4087 "y.tab.c"
    break;

  case 309: /* addfooter_value: ADDFOOTER QSTRING  */
#line 1272 "conf_yacc.y"
                                          {
				char hdr[QSTRLEN + 1];

				acl_add_addfooter(quotepath(hdr, (yyvsp[0].qstring), QSTRLEN));
			}
#line 4097 "y.tab.c"
    break;

  case 310: /* subjtag_value: SUBJTAG QSTRING  */
#line 1278 "conf_yacc.y"
                                        {
				char hdr[QSTRLEN + 1];

				acl_add_subjtag(quotepath(hdr, (yyvsp[0].qstring), QSTRLEN));
			}
#line 4107 "y.tab.c"
    break;

  case 311: /* maxpeek_value: MAXPEEK TNUMBER  */
#line 1284 "conf_yacc.y"
                                        {
				acl_add_maxpeek(atoi((yyvsp[0].delay)));
			}
#line 4115 "y.tab.c"
    break;

  case 312: /* no_clause: NO  */
#line 1288 "conf_yacc.y"
                           { acl_negate_clause(); }
#line 4121 "y.tab.c"
    break;

  case 313: /* time_clause: TIME clockspec clockspec clockspec clockspec clockspec  */
#line 1292 "conf_yacc.y"
                        { acl_add_clause(AC_CLOCKSPEC, register_clock()); }
#line 4127 "y.tab.c"
    break;

  case 314: /* p0f_clause: P0F QSTRING  */
#line 1295 "conf_yacc.y"
                                    { 
#ifdef USE_P0F
			char name[QSTRLEN + 1];

			acl_add_clause(AC_P0F, 
				       quotepath(name, (yyvsp[0].qstring), QSTRLEN));
#else
			acl_drop();
			mg_log(LOG_INFO, 
			    "p0f support not compiled in, ignore line %d", 
			    conf_line);
#endif
			}
#line 4145 "y.tab.c"
    break;

  case 315: /* p0fregex_clause: P0F REGEX  */
#line 1309 "conf_yacc.y"
                                  { 
#ifdef USE_P0F
			acl_add_clause(AC_P0F_RE, (yyvsp[0].regex)); 
#else
			acl_drop();
			mg_log(LOG_INFO, 
			    "p0f support not compiled in, ignore line %d", 
			    conf_line);
#endif
			}
#line 4160 "y.tab.c"
    break;

  case 316: /* spamd_clause: SPAMD  */
#line 1320 "conf_yacc.y"
                              {
#ifdef USE_SPAMD
				acl_add_clause(AC_SA, NULL);
#else
				mg_log(LOG_INFO, 
				       "spamassassin support "
				       "not compiled in, ignore line %d", 
				       conf_line);
#endif
			}
#line 4175 "y.tab.c"
    break;

  case 317: /* spamd_score_clause: SPAMD OP TNUMBER  */
#line 1331 "conf_yacc.y"
                                         {
#ifdef USE_SPAMD
				struct acl_opnum_data aond;

				aond.op = (yyvsp[-1].op);
				aond.num = atoi((yyvsp[0].delay));
				
				acl_add_clause(AC_SASCORE, &aond);
#else
				mg_log(LOG_INFO, 
				       "spamassassin support not compiled in, ignore line %d", 
				 conf_line);
#endif
			}
#line 4194 "y.tab.c"
    break;

  case 318: /* spamd_score_prop_clause: SPAMD OP PROP  */
#line 1347 "conf_yacc.y"
                                              {
			struct acl_opnum_prop aonp;

			aonp.aonp_op = (yyvsp[-1].op);
			aonp.aonp_type = AONP_SPAMD;
			aonp.aonp_name = (yyvsp[0].prop) + 1; /* + 1 to strip leading $ */
			acl_add_clause(AC_SASCORE_PROP, &aonp);
		}
#line 4207 "y.tab.c"
    break;

  case 319: /* geoip_clause: GEOIP QSTRING  */
#line 1357 "conf_yacc.y"
                                      {
#if defined(USE_GEOIP) || defined(USE_GEOIP2)
				char ccode[IPADDRSTRLEN + 1];

				acl_add_clause(AC_GEOIP, 
				    quotepath(ccode, (yyvsp[0].qstring), IPADDRSTRLEN));
#else
				acl_drop();
				mg_log(LOG_INFO, 
				    "GeoIP support not compiled in, "
				    "ignoting line %d", 
				    conf_line);
#endif
			}
#line 4226 "y.tab.c"
    break;

  case 320: /* helo_clause: HELO QSTRING  */
#line 1373 "conf_yacc.y"
                                     {
				char string[QSTRLEN + 1];

				acl_add_clause(AC_HELO, 
				    quotepath(string, (yyvsp[0].qstring), QSTRLEN));
			}
#line 4237 "y.tab.c"
    break;

  case 321: /* heloregex_clause: HELO REGEX  */
#line 1381 "conf_yacc.y"
                                   { acl_add_clause(AC_HELO_RE, (yyvsp[0].regex)); }
#line 4243 "y.tab.c"
    break;

  case 322: /* fromaddr_clause: FROM EMAIL  */
#line 1384 "conf_yacc.y"
                                   { acl_add_clause(AC_FROM, (yyvsp[0].email)); }
#line 4249 "y.tab.c"
    break;

  case 323: /* rawfromaddr_clause: RAWFROM EMAIL  */
#line 1387 "conf_yacc.y"
                                      { acl_add_clause(AC_RAWFROM, (yyvsp[0].email)); }
#line 4255 "y.tab.c"
    break;

  case 324: /* fromregex_clause: FROM REGEX  */
#line 1390 "conf_yacc.y"
                                   { acl_add_clause(AC_FROM_RE, (yyvsp[0].regex)); }
#line 4261 "y.tab.c"
    break;

  case 325: /* rawfromregex_clause: RAWFROM REGEX  */
#line 1393 "conf_yacc.y"
                                      { acl_add_clause(AC_RAWFROM_RE, (yyvsp[0].regex)); }
#line 4267 "y.tab.c"
    break;

  case 326: /* rcptaddr_clause: RCPT EMAIL  */
#line 1396 "conf_yacc.y"
                                   { acl_add_clause(AC_RCPT, (yyvsp[0].email)); }
#line 4273 "y.tab.c"
    break;

  case 327: /* rcptregex_clause: RCPT REGEX  */
#line 1399 "conf_yacc.y"
                                   { acl_add_clause(AC_RCPT_RE, (yyvsp[0].regex)); }
#line 4279 "y.tab.c"
    break;

  case 328: /* domainaddr_clause: DOMAIN DOMAINNAME  */
#line 1402 "conf_yacc.y"
                                          { acl_add_clause(AC_DOMAIN, (yyvsp[0].domainname)); }
#line 4285 "y.tab.c"
    break;

  case 329: /* domainregex_clause: DOMAIN REGEX  */
#line 1405 "conf_yacc.y"
                                     { acl_add_clause(AC_DOMAIN_RE, (yyvsp[0].regex)); }
#line 4291 "y.tab.c"
    break;

  case 330: /* dnsrbl_clause: DNSRBL QSTRING  */
#line 1408 "conf_yacc.y"
                                       { 
#ifdef USE_DNSRBL
			char path[QSTRLEN + 1];

			acl_add_clause(AC_DNSRBL, quotepath(path, (yyvsp[0].qstring), QSTRLEN));
#else
			acl_drop();
			mg_log(LOG_INFO, 
			    "DNSRBL support not compiled in, ignore line %d", 
			    conf_line);
#endif
			}
#line 4308 "y.tab.c"
    break;

  case 331: /* mx_clause: MX CIDR  */
#line 1424 "conf_yacc.y"
                                {
#ifdef USE_MX

                        acl_add_clause(AC_MX, &(yyvsp[0].cidr));
#else
                        acl_drop();
                        mg_log(LOG_INFO,
                            "MX support not compiled in, ignore line %d",
                            conf_line);
#endif
                        }
#line 4324 "y.tab.c"
    break;

  case 332: /* macro_clause: SM_MACRO QSTRING  */
#line 1439 "conf_yacc.y"
                                 {
			char qstring[QSTRLEN + 1];

			acl_add_clause(AC_MACRO,
				       quotepath(qstring, (yyvsp[0].qstring), QSTRLEN));
		}
#line 4335 "y.tab.c"
    break;

  case 333: /* ratelimit_clause: RATELIMIT QSTRING  */
#line 1447 "conf_yacc.y"
                                   {
			char qstring[QSTRLEN + 1];

			acl_add_clause(AC_RATELIMIT,
				       quotepath(qstring, (yyvsp[0].qstring), QSTRLEN));
		}
#line 4346 "y.tab.c"
    break;

  case 334: /* header_clause: GLHEADER QSTRING  */
#line 1455 "conf_yacc.y"
                                 {
			char qstring[QSTRLEN + 1];

			acl_add_clause(AC_HEADER,
				       quotepath(qstring, (yyvsp[0].qstring), QSTRLEN));
		}
#line 4357 "y.tab.c"
    break;

  case 335: /* headerregex_clause: GLHEADER REGEX  */
#line 1463 "conf_yacc.y"
                                       { acl_add_clause(AC_HEADER_RE, (yyvsp[0].regex)); }
#line 4363 "y.tab.c"
    break;

  case 336: /* tarpit_clause: TARPIT TDELAY  */
#line 1465 "conf_yacc.y"
                                      {
#ifdef HAVE_DATA_CALLBACK
				time_t t = humanized_atoi((yyvsp[0].delay));
				acl_add_clause(AC_TARPIT, &t);
#else
				mg_log(LOG_ERR, "libmilter >= 8.14 is required "
						"for tarpit, line %d",
						conf_line);
				exit(EX_DATAERR);
#endif
			}
#line 4379 "y.tab.c"
    break;

  case 337: /* nsupdate_clause: NSUPDATE QSTRING  */
#line 1478 "conf_yacc.y"
                                         {
#ifdef USE_NSUPDATE
				char name[QSTRLEN + 1];
				struct nsupdate_entry *nse;

				(void)quotepath(name, (yyvsp[0].qstring), QSTRLEN);
				if ((nse = nsupdate_byname(name)) == NULL) {
					mg_log(LOG_ERR, "nsupdate \"%s\" "
					    "not found", name);
					exit(EX_DATAERR);
				} else {
					acl_add_clause(AC_NSUPDATE, nse);
				}
#else
				mg_log(LOG_INFO, 
				    "nsupdate support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
			}
#line 4404 "y.tab.c"
    break;

  case 338: /* log_clause: LOG QSTRING  */
#line 1500 "conf_yacc.y"
                                    {
				char qstring[QSTRLEN + 1];

				acl_add_clause(AC_LOG,
				    quotepath(qstring, (yyvsp[0].qstring), QSTRLEN));
			}
#line 4415 "y.tab.c"
    break;

  case 339: /* body_clause: BODY QSTRING  */
#line 1508 "conf_yacc.y"
                                     {
				char qstring[QSTRLEN + 1];

				acl_add_clause(AC_BODY,
				    quotepath(qstring, (yyvsp[0].qstring), QSTRLEN));
			}
#line 4426 "y.tab.c"
    break;

  case 340: /* bodyregex_clause: BODY REGEX  */
#line 1516 "conf_yacc.y"
                                   { acl_add_clause(AC_BODY_RE, (yyvsp[0].regex)); }
#line 4432 "y.tab.c"
    break;

  case 341: /* auth_clause: AUTH QSTRING  */
#line 1519 "conf_yacc.y"
                                     {
				char qstring[QSTRLEN + 1];

				acl_add_clause(AC_AUTH,
				    quotepath(qstring, (yyvsp[0].qstring), QSTRLEN));
				conf.c_noauth = 1; 
			}
#line 4444 "y.tab.c"
    break;

  case 342: /* authregex_clause: AUTH REGEX  */
#line 1528 "conf_yacc.y"
                                   { 
				acl_add_clause(AC_AUTH_RE, (yyvsp[0].regex)); 
				conf.c_noauth = 1; 
			}
#line 4453 "y.tab.c"
    break;

  case 343: /* tls_clause: TLS QSTRING  */
#line 1534 "conf_yacc.y"
                                    {
				char qstring[QSTRLEN + 1];

				acl_add_clause(AC_TLS,
				    quotepath(qstring, (yyvsp[0].qstring), QSTRLEN));
				conf.c_noauth = 1; 
			}
#line 4465 "y.tab.c"
    break;

  case 344: /* tlsregex_clause: TLS REGEX  */
#line 1543 "conf_yacc.y"
                                  { 
				acl_add_clause(AC_TLS_RE, (yyvsp[0].regex)); 
				conf.c_noauth = 1;  
			}
#line 4474 "y.tab.c"
    break;

  case 345: /* spf_clause: SPF SPF_STATUS  */
#line 1549 "conf_yacc.y"
                                       {
#if (defined(HAVE_SPF) || defined(HAVE_SPF_ALT) || \
     defined(HAVE_SPF2_10) || defined(HAVE_SPF2))
				acl_add_clause(AC_SPF, &(yyvsp[0].spf_status)); 
				conf.c_nospf = 1;
#else
				acl_drop();
				mg_log(LOG_INFO, 
				    "SPF support not compiled in,  "
				    "ignore line %d", 
				    conf_line);
#endif
			}
#line 4492 "y.tab.c"
    break;

  case 346: /* spf_compat_clause: SPF  */
#line 1564 "conf_yacc.y"
                             {
#if (defined(HAVE_SPF) || defined(HAVE_SPF_ALT) || \
     defined(HAVE_SPF2_10) || defined(HAVE_SPF2))
				enum spf_status status = MGSPF_PASS;

				acl_add_clause(AC_SPF, &status); 
				conf.c_nospf = 1;
#else
				acl_drop();
				mg_log(LOG_INFO, 
				    "SPF support not compiled in, "
				    "ignore line %d", 
				    conf_line);
#endif
			}
#line 4512 "y.tab.c"
    break;

  case 347: /* dkim_clause: DKIMCHECK SPF_STATUS  */
#line 1581 "conf_yacc.y"
                                             {
#ifdef USE_DKIM
				acl_add_clause(AC_DKIM, &(yyvsp[0].spf_status)); 
#else
				acl_drop();
				mg_log(LOG_INFO, 
				    "DKIM support not compiled in,  "
				    "ignore line %d", 
				    conf_line);
#endif
			}
#line 4528 "y.tab.c"
    break;

  case 348: /* urlcheck_clause: URLCHECK QSTRING  */
#line 1594 "conf_yacc.y"
                                         { 
#ifdef USE_CURL
			char path[QSTRLEN + 1];

			acl_add_clause(AC_URLCHECK, 
				       quotepath(path, (yyvsp[0].qstring), QSTRLEN));
#else
			acl_drop();
			mg_log(LOG_INFO, 
			    "CURL support not compiled in, ignore line %d", 
			    conf_line);
#endif
			}
#line 4546 "y.tab.c"
    break;

  case 349: /* ldapcheck_clause: LDAPCHECK QSTRING  */
#line 1608 "conf_yacc.y"
                                          { 
#ifdef USE_LDAP
			char name[QSTRLEN + 1];

			acl_add_clause(AC_LDAPCHECK, 
				       quotepath(name, (yyvsp[0].qstring), QSTRLEN));
#else
			acl_drop();
			mg_log(LOG_INFO, 
			    "LDAP support not compiled in, ignore line %d", 
			    conf_line);
#endif
			}
#line 4564 "y.tab.c"
    break;

  case 350: /* eqsetstring_clause: SET PROP EQSET QSTRING  */
#line 1623 "conf_yacc.y"
                                               {
			struct prop_data upd;
			char qstring[QSTRLEN + 1];

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = quotepath(qstring, (yyvsp[0].qstring), QSTRLEN);

			acl_add_clause(AC_EQSET, &upd);
		}
#line 4578 "y.tab.c"
    break;

  case 351: /* eqrsetstring_clause: RSET PROP EQSET QSTRING  */
#line 1634 "conf_yacc.y"
                                                {
			struct prop_data upd;
			char qstring[QSTRLEN + 1];

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = quotepath(qstring, (yyvsp[0].qstring), QSTRLEN);

			acl_add_clause(AC_EQRSET, &upd);
		}
#line 4592 "y.tab.c"
    break;

  case 352: /* incsetstring_clause: SET PROP INCSET QSTRING  */
#line 1645 "conf_yacc.y"
                                                {
			struct prop_data upd;
			char qstring[QSTRLEN + 1];

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = quotepath(qstring, (yyvsp[0].qstring), QSTRLEN);

			acl_add_clause(AC_INCSET, &upd);
		}
#line 4606 "y.tab.c"
    break;

  case 353: /* incrsetstring_clause: RSET PROP INCSET QSTRING  */
#line 1656 "conf_yacc.y"
                                                 {
			struct prop_data upd;
			char qstring[QSTRLEN + 1];

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = quotepath(qstring, (yyvsp[0].qstring), QSTRLEN);

			acl_add_clause(AC_INCRSET, &upd);
		}
#line 4620 "y.tab.c"
    break;

  case 354: /* decsetstring_clause: SET PROP DECSET QSTRING  */
#line 1667 "conf_yacc.y"
                                                {
			struct prop_data upd;
			char qstring[QSTRLEN + 1];

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = quotepath(qstring, (yyvsp[0].qstring), QSTRLEN);

			acl_add_clause(AC_DECSET, &upd);
		}
#line 4634 "y.tab.c"
    break;

  case 355: /* decrsetstring_clause: RSET PROP DECSET QSTRING  */
#line 1678 "conf_yacc.y"
                                                 {
			struct prop_data upd;
			char qstring[QSTRLEN + 1];

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = quotepath(qstring, (yyvsp[0].qstring), QSTRLEN);

			acl_add_clause(AC_DECRSET, &upd);
		}
#line 4648 "y.tab.c"
    break;

  case 356: /* eqsetnum_clause: SET PROP EQSET TNUMBER  */
#line 1689 "conf_yacc.y"
                                               {
			struct prop_data upd;

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = (yyvsp[0].delay);

			acl_add_clause(AC_EQSET, &upd);
		}
#line 4661 "y.tab.c"
    break;

  case 357: /* eqrsetnum_clause: RSET PROP EQSET TNUMBER  */
#line 1699 "conf_yacc.y"
                                                {
			struct prop_data upd;

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = (yyvsp[0].delay);

			acl_add_clause(AC_EQRSET, &upd);
		}
#line 4674 "y.tab.c"
    break;

  case 358: /* incsetnum_clause: SET PROP INCSET TNUMBER  */
#line 1709 "conf_yacc.y"
                                                {
			struct prop_data upd;

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = (yyvsp[0].delay);

			acl_add_clause(AC_INCSET, &upd);
		}
#line 4687 "y.tab.c"
    break;

  case 359: /* incrsetnum_clause: RSET PROP INCSET TNUMBER  */
#line 1719 "conf_yacc.y"
                                                 {
			struct prop_data upd;

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = (yyvsp[0].delay);

			acl_add_clause(AC_INCRSET, &upd);
		}
#line 4700 "y.tab.c"
    break;

  case 360: /* decsetnum_clause: SET PROP DECSET TNUMBER  */
#line 1729 "conf_yacc.y"
                                                {
			struct prop_data upd;

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = (yyvsp[0].delay);

			acl_add_clause(AC_DECSET, &upd);
		}
#line 4713 "y.tab.c"
    break;

  case 361: /* decrsetnum_clause: RSET PROP DECSET TNUMBER  */
#line 1739 "conf_yacc.y"
                                                 {
			struct prop_data upd;

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = (yyvsp[0].delay);

			acl_add_clause(AC_DECRSET, &upd);
		}
#line 4726 "y.tab.c"
    break;

  case 362: /* eqsetprop_clause: SET PROP EQSET PROP  */
#line 1749 "conf_yacc.y"
                                            {
			struct prop_data upd;

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = (yyvsp[0].prop) + 1;

			acl_add_clause(AC_EQSETPROP, &upd);
		}
#line 4739 "y.tab.c"
    break;

  case 363: /* eqrsetprop_clause: RSET PROP EQSET PROP  */
#line 1759 "conf_yacc.y"
                                             {
			struct prop_data upd;

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = (yyvsp[0].prop) + 1;

			acl_add_clause(AC_EQRSETPROP, &upd);
		}
#line 4752 "y.tab.c"
    break;

  case 364: /* incsetprop_clause: SET PROP INCSET PROP  */
#line 1769 "conf_yacc.y"
                                             {
			struct prop_data upd;

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = (yyvsp[0].prop) + 1;

			acl_add_clause(AC_INCSETPROP, &upd);
		}
#line 4765 "y.tab.c"
    break;

  case 365: /* incrsetprop_clause: RSET PROP INCSET PROP  */
#line 1779 "conf_yacc.y"
                                              {
			struct prop_data upd;

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = (yyvsp[0].prop) + 1;

			acl_add_clause(AC_INCRSETPROP, &upd);
		}
#line 4778 "y.tab.c"
    break;

  case 366: /* decsetprop_clause: SET PROP DECSET PROP  */
#line 1789 "conf_yacc.y"
                                             {
			struct prop_data upd;

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = (yyvsp[0].prop) + 1;

			acl_add_clause(AC_DECSETPROP, &upd);
		}
#line 4791 "y.tab.c"
    break;

  case 367: /* decrsetprop_clause: RSET PROP DECSET PROP  */
#line 1799 "conf_yacc.y"
                                              {
			struct prop_data upd;

			upd.upd_name = (yyvsp[-2].prop);
			upd.upd_data = (yyvsp[0].prop) + 1;

			acl_add_clause(AC_DECRSETPROP, &upd);
		}
#line 4804 "y.tab.c"
    break;

  case 368: /* propstr_clause: PROP QSTRING  */
#line 1809 "conf_yacc.y"
                                     {
			struct prop_data upd;
			char qstring[QSTRLEN + 1];

			upd.upd_name = (yyvsp[-1].prop);
			upd.upd_data = quotepath(qstring, (yyvsp[0].qstring), QSTRLEN);

			acl_add_clause(AC_PROP_STR, &upd);
		}
#line 4818 "y.tab.c"
    break;

  case 369: /* propglob_clause: STAR PROP QSTRING  */
#line 1820 "conf_yacc.y"
                                          {
			struct prop_data upd;
			char qstring[QSTRLEN + 1];

			upd.upd_name = (yyvsp[-1].prop);
			upd.upd_data = quotepath(qstring, (yyvsp[0].qstring), QSTRLEN);

			acl_add_clause(AC_PROP_GLOB, &upd);
		}
#line 4832 "y.tab.c"
    break;

  case 370: /* propnum_clause: PROP OP TNUMBER  */
#line 1831 "conf_yacc.y"
                                        {
			struct prop_data upd;
			struct acl_opnum_data aond;

			upd.upd_name = (yyvsp[-2].prop);
			aond.op = (yyvsp[-1].op);
			aond.num = humanized_atoi((yyvsp[0].delay));
			upd.upd_data = &aond;
				
			acl_add_clause(AC_PROP_NUM, &upd);
		}
#line 4848 "y.tab.c"
    break;

  case 371: /* propprop_clause: PROP OP PROP  */
#line 1844 "conf_yacc.y"
                                     {
			struct acl_prop_pop apop;

			/* +1 to skip leading $ */
			apop.apop_lhs = (yyvsp[-2].prop) + 1;
			apop.apop_op = (yyvsp[-1].op);
			apop.apop_rhs = (yyvsp[0].prop) + 1;
				
			acl_add_clause(AC_PROP_PROP, &apop);
		}
#line 4863 "y.tab.c"
    break;

  case 372: /* propregex_clause: PROP REGEX  */
#line 1856 "conf_yacc.y"
                                   {
			struct prop_data upd;

			upd.upd_name = (yyvsp[-1].prop);
			upd.upd_data = (yyvsp[0].regex);
			acl_add_clause(AC_PROP_RE, &upd);
		}
#line 4875 "y.tab.c"
    break;

  case 373: /* bodyprop_clause: BODY PROP  */
#line 1865 "conf_yacc.y"
                                  {
			/* + 1 to strip leading $ */
			acl_add_clause(AC_BODY_PROP, (yyvsp[0].prop) + 1);
		}
#line 4884 "y.tab.c"
    break;

  case 374: /* headerprop_clause: GLHEADER PROP  */
#line 1871 "conf_yacc.y"
                                      {
			/* + 1 to strip leadin $ */
			acl_add_clause(AC_HEADER_PROP, (yyvsp[0].prop) + 1);
		}
#line 4893 "y.tab.c"
    break;

  case 375: /* list_clause: LIST QSTRING  */
#line 1877 "conf_yacc.y"
                                     { 
				char path[QSTRLEN + 1];

				acl_add_clause(AC_LIST, 
					       quotepath(path, (yyvsp[0].qstring), QSTRLEN));
			}
#line 4904 "y.tab.c"
    break;

  case 376: /* netblock_clause: ADDR IPADDR CIDR  */
#line 1884 "conf_yacc.y"
                                         {
				struct acl_netblock_data and;

				and.addr = SA(&(yyvsp[-1].ipaddr));
				and.salen = sizeof(struct sockaddr_in);
				and.cidr = (yyvsp[0].cidr);

				acl_add_clause(AC_NETBLOCK, &and);
			}
#line 4918 "y.tab.c"
    break;

  case 377: /* netblock_clause: ADDR IPADDR  */
#line 1893 "conf_yacc.y"
                                        {
				struct acl_netblock_data and;

				and.addr = SA(&(yyvsp[0].ipaddr));
				and.salen = sizeof(struct sockaddr_in);
				and.cidr = 32;

				acl_add_clause(AC_NETBLOCK, &and);
			}
#line 4932 "y.tab.c"
    break;

  case 378: /* netblock_clause: ADDR IP6ADDR CIDR  */
#line 1902 "conf_yacc.y"
                                         {
#ifdef AF_INET6
				struct acl_netblock_data and;

				and.addr = SA(&(yyvsp[-1].ip6addr));
				and.salen = sizeof(struct sockaddr_in6);
				and.cidr = (yyvsp[0].cidr);

				acl_add_clause(AC_NETBLOCK, &and);
#else
				acl_drop();
				mg_log(LOG_INFO, 
				    "IPv6 is not supported, ignore line %d",
				    conf_line);
#endif
			}
#line 4953 "y.tab.c"
    break;

  case 379: /* netblock_clause: ADDR IP6ADDR  */
#line 1918 "conf_yacc.y"
                                        {
#ifdef AF_INET6
				struct acl_netblock_data and;

				and.addr = SA(&(yyvsp[0].ip6addr));
				and.salen = sizeof(struct sockaddr_in6);
				and.cidr = 128;

				acl_add_clause(AC_NETBLOCK, &and);
#else
				acl_drop();
				mg_log(LOG_INFO, "IPv6 is not supported, "
				     "ignore line %d", conf_line);
#endif
		}
#line 4973 "y.tab.c"
    break;

  case 380: /* dracdb: DRAC DB QSTRING  */
#line 1935 "conf_yacc.y"
                                        { 
#ifdef USE_DRAC
				conf.c_dracdb = 
					    quotepath(conf.c_dracdb_storage, (yyvsp[0].qstring), QSTRLEN);
#else
				mg_log(LOG_INFO, "DRAC support not compiled "
				    "in, ignore line %d", conf_line);
#endif
		}
#line 4987 "y.tab.c"
    break;

  case 381: /* msgsize_clause: MSGSIZE OP TNUMBER  */
#line 1946 "conf_yacc.y"
                                           {
				struct acl_opnum_data aond;

				aond.op = (yyvsp[-1].op);
				aond.num = humanized_atoi((yyvsp[0].delay));
				
				acl_add_clause(AC_MSGSIZE, &aond);
		}
#line 5000 "y.tab.c"
    break;

  case 382: /* msgsize_prop_clause: MSGSIZE OP PROP  */
#line 1956 "conf_yacc.y"
                                        {
			struct acl_opnum_prop aonp;

			aonp.aonp_op = (yyvsp[-1].op);
			aonp.aonp_type = AONP_MSGSIZE;
			aonp.aonp_name = (yyvsp[0].prop) + 1; /* + 1 to strip leading $ */
			acl_add_clause(AC_MSGSIZE_PROP, &aonp);
		}
#line 5013 "y.tab.c"
    break;

  case 383: /* rcptcount_clause: RCPTCOUNT OP TNUMBER  */
#line 1966 "conf_yacc.y"
                                             {
				struct acl_opnum_data aond;

				aond.op = (yyvsp[-1].op);
				aond.num = humanized_atoi((yyvsp[0].delay));
				
				acl_add_clause(AC_RCPTCOUNT, &aond);
		}
#line 5026 "y.tab.c"
    break;

  case 384: /* rcptcount_prop_clause: RCPTCOUNT OP PROP  */
#line 1976 "conf_yacc.y"
                                          {
			struct acl_opnum_prop aonp;

			aonp.aonp_op = (yyvsp[-1].op);
			aonp.aonp_type = AONP_RCPTCOUNT;
			aonp.aonp_name = (yyvsp[0].prop) + 1; /* + 1 to strip leading $ */
			acl_add_clause(AC_RCPTCOUNT_PROP, &aonp);
		}
#line 5039 "y.tab.c"
    break;

  case 385: /* nodrac: NODRAC  */
#line 1986 "conf_yacc.y"
                                { conf.c_nodrac = 1; }
#line 5045 "y.tab.c"
    break;

  case 386: /* maxpeek: MAXPEEK TNUMBER  */
#line 1989 "conf_yacc.y"
                                        { 
				conf.c_maxpeek = humanized_atoi((yyvsp[0].delay)); 
				acl_maxpeek_fixup(conf.c_maxpeek);
			}
#line 5054 "y.tab.c"
    break;

  case 389: /* dnsrbldefip: DNSRBL QSTRING DOMAINNAME IPADDR  */
#line 1998 "conf_yacc.y"
                                                 {
#ifdef USE_DNSRBL
			char path[QSTRLEN + 1];

			dnsrbl_source_add(quotepath(path, (yyvsp[-2].qstring), QSTRLEN), 
			    (yyvsp[-1].domainname), SA(&(yyvsp[0].ipaddr)), 32);
#else
			mg_log(LOG_INFO, 
			    "DNSRBL support not compiled in, ignore  line %d", 
			    conf_line);
#endif
		}
#line 5071 "y.tab.c"
    break;

  case 390: /* dnsrbldefnetblock: DNSRBL QSTRING DOMAINNAME IPADDR CIDR  */
#line 2012 "conf_yacc.y"
                                                              {
#ifdef USE_DNSRBL
			char path[QSTRLEN + 1];

			dnsrbl_source_add(quotepath(path, (yyvsp[-3].qstring), QSTRLEN), 
			    (yyvsp[-2].domainname), SA(&(yyvsp[-1].ipaddr)), (yyvsp[0].cidr));
#else
			mg_log(LOG_INFO, 
			    "DNSRBL support not compiled in, ignore line %d", 
			    conf_line);
#endif
		}
#line 5088 "y.tab.c"
    break;

  case 394: /* macrodef_string: SM_MACRO QSTRING QSTRING QSTRING  */
#line 2028 "conf_yacc.y"
                                                         { 
				char name[QSTRLEN + 1];
				char macro[QSTRLEN + 1];
				char value[QSTRLEN + 1];

				macro_add_string(quotepath(name, (yyvsp[-2].qstring), QSTRLEN), 
				    quotepath(macro, (yyvsp[-1].qstring), QSTRLEN),
				    quotepath(value, (yyvsp[0].qstring), QSTRLEN));
			}
#line 5102 "y.tab.c"
    break;

  case 395: /* ldapcheckdef: LDAPCHECK QSTRING QSTRING ldapcheckdef_flags  */
#line 2039 "conf_yacc.y"
                                                             {
#ifdef USE_LDAP
			char name[QSTRLEN + 1];
			char url[QSTRLEN + 1];

			ldapcheck_def_add(quotepath(name, (yyvsp[-2].qstring), QSTRLEN), 
			    quotepath(url, (yyvsp[-1].qstring), QSTRLEN), ldapcheck_gflags);
#else
			mg_log(LOG_INFO, 
			    "LDAP support not compiled in, ignore  line %d", 
			    conf_line);
#endif
		}
#line 5120 "y.tab.c"
    break;

  case 400: /* ldapcheckdef_clear: CLEAR  */
#line 2060 "conf_yacc.y"
                               { 
#ifdef USE_LDAP
				ldapcheck_gflags |= L_CLEARPROP; 
#else
			mg_log(LOG_INFO, 
			    "LDAP support not compiled in, ignore line %d", 
			    conf_line);
#endif
			}
#line 5134 "y.tab.c"
    break;

  case 401: /* ldapcheckdef_domatch: DOMATCH  */
#line 2070 "conf_yacc.y"
                                 { 
#ifdef USE_LDAP
				ldapcheck_gflags |= L_DOMATCH; 
#else
			mg_log(LOG_INFO, 
			    "LDAP support not compiled in, ignore line %d", 
			    conf_line);
#endif
			}
#line 5148 "y.tab.c"
    break;

  case 402: /* ldapcheckdef_noescape: NOESCAPE  */
#line 2081 "conf_yacc.y"
                                  { 
#ifdef USE_LDAP
				ldapcheck_gflags |= L_NOESCAPE; 
#else
			mg_log(LOG_INFO, 
			    "LDAP support not compiled in, ignore line %d", 
			    conf_line);
#endif
			}
#line 5162 "y.tab.c"
    break;

  case 403: /* urlcheckdef: URLCHECK QSTRING QSTRING TNUMBER urlcheckdef_flags  */
#line 2092 "conf_yacc.y"
                                                                   {
#ifdef USE_CURL
			char path1[QSTRLEN + 1];
			char path2[QSTRLEN + 1];

			urlcheck_def_add(quotepath(path1, (yyvsp[-3].qstring), QSTRLEN), 
			    quotepath(path2, (yyvsp[-2].qstring), QSTRLEN), atoi((yyvsp[-1].delay)), 
			    urlcheck_gflags);
#else
			mg_log(LOG_INFO, 
			    "CURL support not compiled in, ignore  line %d", 
			    conf_line);
#endif
		}
#line 5181 "y.tab.c"
    break;

  case 410: /* urlcheckdef_postmsg: POSTMSG  */
#line 2116 "conf_yacc.y"
                                { 
#ifdef USE_CURL
				urlcheck_gflags |= U_POSTMSG; 
#else
			mg_log(LOG_INFO, 
			    "CURL support not compiled in, ignore line %d", 
			    conf_line);
#endif
			}
#line 5195 "y.tab.c"
    break;

  case 411: /* urlcheckdef_noencode: NOENCODE  */
#line 2126 "conf_yacc.y"
                                        { 
#ifdef USE_CURL
				urlcheck_gflags |= U_NOENCODE; 
#else
			mg_log(LOG_INFO, 
			    "CURL support not compiled in, ignore line %d", 
			    conf_line);
#endif
			}
#line 5209 "y.tab.c"
    break;

  case 412: /* urlcheckdef_getprop: GETPROP  */
#line 2136 "conf_yacc.y"
                                { 
#ifdef USE_CURL
				urlcheck_gflags |= U_GETPROP; 
#else
			mg_log(LOG_INFO, 
			    "CURL support not compiled in, ignore line %d", 
			    conf_line);
#endif
			}
#line 5223 "y.tab.c"
    break;

  case 413: /* urlcheckdef_clear: CLEAR  */
#line 2146 "conf_yacc.y"
                               { 
#ifdef USE_CURL
				urlcheck_gflags |= U_CLEARPROP; 
#else
			mg_log(LOG_INFO, 
			    "CURL support not compiled in, ignore line %d", 
			    conf_line);
#endif
			}
#line 5237 "y.tab.c"
    break;

  case 414: /* urlcheckdef_fork: FORK  */
#line 2156 "conf_yacc.y"
                              {
#ifdef USE_CURL
				urlcheck_gflags |= U_FORK;
#else
			mg_log(LOG_INFO, 
			    "CURL support not compiled in, ignore line %d", 
			    conf_line);
#endif
			}
#line 5251 "y.tab.c"
    break;

  case 415: /* ldapconfdef: LDAPCONF QSTRING ldaptimeout LDAPBINDDN QSTRING LDAPBINDPW QSTRING  */
#line 2168 "conf_yacc.y"
                                                      {
#ifdef USE_LDAP
			char uris[QSTRLEN + 1];
			char bdn[QSTRLEN +1 ];
			char bpw[QSTRLEN + 1 ];
			ldapcheck_conf_add(
				quotepath(uris, (yyvsp[-5].qstring), QSTRLEN),
				quotepath(bdn, (yyvsp[-2].qstring), QSTRLEN),
				quotepath(bpw, (yyvsp[0].qstring), QSTRLEN));
#else
			mg_log(LOG_INFO, 
			    "LDAP support not compiled in, ignore  line %d", 
			    conf_line);
#endif
		}
#line 5271 "y.tab.c"
    break;

  case 416: /* ldapconfdef: LDAPCONF QSTRING ldaptimeout  */
#line 2183 "conf_yacc.y"
                                       { /* 4.2.1 backward compatiblity */ 
	#ifdef USE_LDAP
				char uris[QSTRLEN + 1];
				char *bdn = NULL;
				char *bpw = NULL;
				ldapcheck_conf_add(
					quotepath(uris, (yyvsp[-1].qstring), QSTRLEN), bdn, bpw);
	#else
				mg_log(LOG_INFO, 
				    "LDAP support not compiled in, ignore  line %d", 
				    conf_line);
	#endif
			}
#line 5289 "y.tab.c"
    break;

  case 417: /* ldaptimeout: GLTIMEOUT TDELAY  */
#line 2197 "conf_yacc.y"
                                 {
#ifdef USE_LDAP
			ldapcheck_timeout_set(humanized_atoi((yyvsp[0].delay)));
#else
			mg_log(LOG_INFO, 
			    "LDAP support not compiled in, ignore  line %d", 
			    conf_line);
#endif
		}
#line 5303 "y.tab.c"
    break;

  case 418: /* ldaptimeout: TNUMBER  */
#line 2206 "conf_yacc.y"
                        {	/* 4.2.1 backward compatiblity */
#ifdef USE_LDAP
			ldapcheck_timeout_set(atoi((yyvsp[0].delay)));
#else
			mg_log(LOG_INFO, 
			    "LDAP support not compiled in, ignore  line %d", 
			    conf_line);
#endif
		}
#line 5317 "y.tab.c"
    break;

  case 420: /* fixldapcheck: FIXLDAPCHECK  */
#line 2217 "conf_yacc.y"
                             { conf.c_fixldapcheck = 1; }
#line 5323 "y.tab.c"
    break;

  case 421: /* localaddrdef: LOCALADDR IPADDR  */
#line 2219 "conf_yacc.y"
                                 { 
			(void)memcpy(&conf.c_localaddr, &(yyvsp[0].ipaddr), 
				     sizeof(struct sockaddr_in));
			IP4TOSTRING(conf.c_localaddr, conf.c_localaddr_string);
		}
#line 5333 "y.tab.c"
    break;

  case 422: /* localaddrdef: LOCALADDR IP6ADDR  */
#line 2224 "conf_yacc.y"
                                  {
#ifdef AF_INET6
			(void)memcpy(&conf.c_localaddr, &(yyvsp[0].ip6addr), 
				     sizeof(struct sockaddr_in6));
			IP6TOSTRING(conf.c_localaddr, conf.c_localaddr_string);
#else
			mg_log(LOG_INFO, "IPv6 is not supported, "
			     "ignore line %d", conf_line);
#endif
		}
#line 5348 "y.tab.c"
    break;

  case 423: /* macrodef_regex: SM_MACRO QSTRING QSTRING REGEX  */
#line 2235 "conf_yacc.y"
                                                       {
				char name[QSTRLEN + 1];
				char macro[QSTRLEN + 1];

				macro_add_regex(quotepath(name, (yyvsp[-2].qstring), QSTRLEN),
				    quotepath(macro, (yyvsp[-1].qstring), QSTRLEN), (yyvsp[0].regex)); 
			}
#line 5360 "y.tab.c"
    break;

  case 424: /* macrodef_unset: SM_MACRO QSTRING QSTRING UNSET  */
#line 2244 "conf_yacc.y"
                                                       {
				char name[QSTRLEN + 1];
				char macro[QSTRLEN + 1];

				macro_add_unset(quotepath(name, (yyvsp[-2].qstring), QSTRLEN),
				    quotepath(macro, (yyvsp[-1].qstring), QSTRLEN));
			}
#line 5372 "y.tab.c"
    break;

  case 426: /* clockspec: clockspec_item  */
#line 2254 "conf_yacc.y"
                                { next_clock_spec(); }
#line 5378 "y.tab.c"
    break;

  case 427: /* clockspec_item: TNUMBER  */
#line 2257 "conf_yacc.y"
                        { add_clock_item(atoi((yyvsp[0].delay)), atoi((yyvsp[0].delay)), 0); }
#line 5384 "y.tab.c"
    break;

  case 428: /* clockspec_item: TNUMBER SLASH TNUMBER  */
#line 2259 "conf_yacc.y"
                        { add_clock_item(atoi((yyvsp[-2].delay)), atoi((yyvsp[-2].delay)), atoi((yyvsp[0].delay)));  }
#line 5390 "y.tab.c"
    break;

  case 429: /* clockspec_item: TNUMBER MINUS TNUMBER  */
#line 2261 "conf_yacc.y"
                        { add_clock_item(atoi((yyvsp[-2].delay)), atoi((yyvsp[0].delay)), 0); }
#line 5396 "y.tab.c"
    break;

  case 430: /* clockspec_item: TNUMBER MINUS TNUMBER SLASH TNUMBER  */
#line 2263 "conf_yacc.y"
                        { add_clock_item(atoi((yyvsp[-4].delay)), atoi((yyvsp[-2].delay)), atoi((yyvsp[0].delay))); }
#line 5402 "y.tab.c"
    break;

  case 431: /* clockspec_item: STAR  */
#line 2265 "conf_yacc.y"
                        { add_clock_item(-1, -1, 0);  }
#line 5408 "y.tab.c"
    break;

  case 432: /* clockspec_item: STAR SLASH TNUMBER  */
#line 2267 "conf_yacc.y"
                        { add_clock_item(-1, -1, atoi((yyvsp[0].delay))); }
#line 5414 "y.tab.c"
    break;

  case 433: /* listdef: LIST QSTRING list_clause  */
#line 2270 "conf_yacc.y"
                                         {
			char path[QSTRLEN + 1];

			all_list_setname(glist, quotepath(path, (yyvsp[-1].qstring), QSTRLEN));
			glist_init();
		}
#line 5425 "y.tab.c"
    break;

  case 434: /* list_clause: HELO OPENLIST qstring_list CLOSELIST  */
#line 2279 "conf_yacc.y"
                        { all_list_settype(glist, AC_HELO_LIST); }
#line 5431 "y.tab.c"
    break;

  case 435: /* list_clause: FROM OPENLIST email_list CLOSELIST  */
#line 2281 "conf_yacc.y"
                        { all_list_settype(glist, AC_FROM_LIST); }
#line 5437 "y.tab.c"
    break;

  case 436: /* list_clause: RAWFROM OPENLIST email_list CLOSELIST  */
#line 2283 "conf_yacc.y"
                        { all_list_settype(glist, AC_RAWFROM_LIST); }
#line 5443 "y.tab.c"
    break;

  case 437: /* list_clause: RCPT OPENLIST email_list CLOSELIST  */
#line 2285 "conf_yacc.y"
                        { all_list_settype(glist, AC_RCPT_LIST); }
#line 5449 "y.tab.c"
    break;

  case 438: /* list_clause: DOMAIN OPENLIST domain_list CLOSELIST  */
#line 2287 "conf_yacc.y"
                        { all_list_settype(glist, AC_DOMAIN_LIST); }
#line 5455 "y.tab.c"
    break;

  case 439: /* list_clause: DNSRBL OPENLIST qstring_list CLOSELIST  */
#line 2289 "conf_yacc.y"
                        { all_list_settype(glist, AC_DNSRBL_LIST); }
#line 5461 "y.tab.c"
    break;

  case 440: /* list_clause: URLCHECK OPENLIST qstring_list CLOSELIST  */
#line 2291 "conf_yacc.y"
                        { all_list_settype(glist, AC_URLCHECK_LIST); }
#line 5467 "y.tab.c"
    break;

  case 441: /* list_clause: BODY OPENLIST qstring_list CLOSELIST  */
#line 2293 "conf_yacc.y"
                        { all_list_settype(glist, AC_BODY_LIST); }
#line 5473 "y.tab.c"
    break;

  case 442: /* list_clause: GLHEADER OPENLIST qstring_list CLOSELIST  */
#line 2295 "conf_yacc.y"
                        { all_list_settype(glist, AC_HEADER_LIST); }
#line 5479 "y.tab.c"
    break;

  case 443: /* list_clause: SM_MACRO OPENLIST qstring_list CLOSELIST  */
#line 2297 "conf_yacc.y"
                        { all_list_settype(glist, AC_MACRO_LIST); }
#line 5485 "y.tab.c"
    break;

  case 444: /* list_clause: ADDR OPENLIST addr_list CLOSELIST  */
#line 2299 "conf_yacc.y"
                        { all_list_settype(glist, AC_NETBLOCK_LIST); }
#line 5491 "y.tab.c"
    break;

  case 445: /* list_clause: AUTH OPENLIST qstring_list CLOSELIST  */
#line 2301 "conf_yacc.y"
                        { all_list_settype(glist, AC_AUTH_LIST); }
#line 5497 "y.tab.c"
    break;

  case 446: /* list_clause: TLS OPENLIST qstring_list CLOSELIST  */
#line 2303 "conf_yacc.y"
                        { all_list_settype(glist, AC_TLS_LIST); }
#line 5503 "y.tab.c"
    break;

  case 447: /* list_clause: TIME OPENLIST qstring_list CLOSELIST  */
#line 2305 "conf_yacc.y"
                        { all_list_settype(glist, AC_CLOCKSPEC_LIST); }
#line 5509 "y.tab.c"
    break;

  case 448: /* list_clause: GEOIP OPENLIST qstring_list CLOSELIST  */
#line 2307 "conf_yacc.y"
                        { all_list_settype(glist, AC_GEOIP_LIST); }
#line 5515 "y.tab.c"
    break;

  case 449: /* list_clause: P0F OPENLIST qstring_list CLOSELIST  */
#line 2309 "conf_yacc.y"
                        { all_list_settype(glist, AC_P0F_LIST); }
#line 5521 "y.tab.c"
    break;

  case 452: /* email_item: EMAIL  */
#line 2316 "conf_yacc.y"
                        { list_add(glist, AC_EMAIL, (yyvsp[0].email)); }
#line 5527 "y.tab.c"
    break;

  case 453: /* email_item: REGEX  */
#line 2317 "conf_yacc.y"
                        { list_add(glist, AC_REGEX, (yyvsp[0].regex)); }
#line 5533 "y.tab.c"
    break;

  case 456: /* domain_item: DOMAINNAME  */
#line 2324 "conf_yacc.y"
                                { list_add(glist, AC_DOMAIN, (yyvsp[0].domainname)); }
#line 5539 "y.tab.c"
    break;

  case 457: /* domain_item: REGEX  */
#line 2325 "conf_yacc.y"
                                { list_add(glist, AC_REGEX, (yyvsp[0].regex)); }
#line 5545 "y.tab.c"
    break;

  case 460: /* qstring_item: QSTRING  */
#line 2332 "conf_yacc.y"
                                { 
			char tmpstr[QSTRLEN + 1];

			list_add(glist, AC_STRING, 
			    quotepath(tmpstr, (yyvsp[0].qstring), QSTRLEN));
		}
#line 5556 "y.tab.c"
    break;

  case 461: /* qstring_item: REGEX  */
#line 2338 "conf_yacc.y"
                                { list_add(glist, AC_REGEX, (yyvsp[0].regex)); }
#line 5562 "y.tab.c"
    break;

  case 464: /* addr_item: IPADDR CIDR  */
#line 2345 "conf_yacc.y"
                            {
			struct acl_netblock_data and;

			and.addr = SA(&(yyvsp[-1].ipaddr));
			and.salen = sizeof(struct sockaddr_in);
			and.cidr = (yyvsp[0].cidr);
			list_add(glist, AC_NETBLOCK, &and);
		}
#line 5575 "y.tab.c"
    break;

  case 465: /* addr_item: IPADDR  */
#line 2353 "conf_yacc.y"
                       {
			struct acl_netblock_data and;

			and.addr = SA(&(yyvsp[0].ipaddr));
			and.salen = sizeof(struct sockaddr_in);
			and.cidr = 32;
			list_add(glist, AC_NETBLOCK, &and);
		}
#line 5588 "y.tab.c"
    break;

  case 466: /* addr_item: IP6ADDR CIDR  */
#line 2361 "conf_yacc.y"
                            {
#ifdef AF_INET6
			struct acl_netblock_data and;

			and.addr = SA(&(yyvsp[-1].ip6addr));
			and.salen = sizeof(struct sockaddr_in6);
			and.cidr = (yyvsp[0].cidr);
			list_add(glist, AC_NETBLOCK, &and);
#else
			mg_log(LOG_INFO,
			    "IPv6 is not supported, ignore line %d",
			    conf_line);
#endif
		}
#line 5607 "y.tab.c"
    break;

  case 467: /* addr_item: IP6ADDR  */
#line 2375 "conf_yacc.y"
                        {
#ifdef AF_INET6
			struct acl_netblock_data and;

			and.addr = SA(&(yyvsp[0].ip6addr));
			and.salen = sizeof(struct sockaddr_in6);
			and.cidr = 128;
			list_add(glist, AC_NETBLOCK, &and);
#else
			mg_log(LOG_ERR, 
			    "IPv6 is not supported, ignore line %d",
			    conf_line);
#endif
		}
#line 5626 "y.tab.c"
    break;


#line 5630 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2390 "conf_yacc.y"

#include "conf_lex.c"
